Unit FileSel;

Interface

Uses Needs, Keyboard, Dos, Strings, Use32;

Function FileSelect(Filter: String): String;

Implementation

Var FiltX: String;

Const
 ByName = 0;
 ByType = 1;
 BySize = 2;
 ByDate = 3;

Type
 PFileEntry = ^TFileEntry;
 TFileEntry = Record
  Name: String[8];
  Ext: String[3];
  Size: DWord;
  Date: DWord;
  DiskSel: Boolean;
  Next: PFileEntry;
 end;
 PFiles = ^TFiles;
 TFiles = Object
  Root: PFileEntry;
  Count: Integer;
  Constructor Init;
  Function Add: PFileEntry;
  Procedure Sort(How: Integer);
  Function GetItem(Index: Integer): PFileEntry;
  Destructor Done;
 end;
 PDirMenuItem = ^TDirMenuItem;
 TDirMenuItem = Record
  FileEntry: PFileEntry;
  Dir: Boolean;
  Next: PDirMenuItem;
 end;
 PDirMenu = ^TDirMenu;
 TDirMenu = Object
  Root, Cur: PDirMenuItem;
  Count: Integer;
  StateIndex: Integer;
  ItemIndex: Integer;
  Constructor Create;
  Function AddItem(FE: PFileEntry; D: Boolean): PDirMenuItem;
  Function GetItem(Index: Integer): PDirMenuItem;
  Procedure Draw;
  Destructor Destroy;
 end;

Procedure TDirMenu.Draw;
Var N: PDirMenuItem; I, J, K: Integer; BC: Byte; DT: DateTime;
begin
 N := Root;
 I := 0;
 While N <> NIL do
 begin
  If I = StateIndex then Break;
  Inc(I);
  N := N^.Next;
 end;
 For J := 3 to 23 do For I := 2 to 79 do With Buffer^[J, I] do
 begin
  Chr := ' ';
  Atr := 0;
 end;
 K := StateIndex;
 For I := 0 to 20 do With N^ do
 begin
  If ItemIndex = K then
  Declare
  Var Z: Integer;
  begin
   BC := 1;
   For Z := 2 to 79 do With Buffer^[3 + I, Z] do
   begin
    Chr := ' ';
    Atr := 1 shl 4;
   end;
  end Else BC := 0;
  If Dir then With FileEntry^ do
  begin
   PutString(4, 3 + I, BC, 14, Name);
   PutString(15, 3 + I, BC, 14, Ext);
   If not DiskSel then
   begin
    PutString(34, 3 + I, BC, 14, 'Directory');
    UnPackTime(Date, DT);
    With DT do PutString(59, 3 + I, BC, 14,
    ZeroString(IntToStr(Day), 2) + '.' +
    ZeroString(IntToStr(Month), 2) + '.' +
    ZeroString(IntToStr(Year), 4) + ' ' +
    ZeroString(IntToStr(Hour), 2) + ':' +
    ZeroString(IntToStr(Min), 2) + ':' +
    ZeroString(IntToStr(Sec), 2));
   end Else PutString(34, 3 + I, BC, 14, 'Disk Drive');
  end Else With FileEntry^ do
  begin
   PutString(4, 3 + I, BC, 15, Name);
   PutString(15, 3 + I, BC, 15, Ext);
   PutString(21, 3 + I, BC, 15, SpaceString(IntToStr(Size), 10));
   UnPackTime(Date, DT);
   With DT do PutString(59, 3 + I, BC, 15,
   ZeroString(IntToStr(Day), 2) + '.' +
   ZeroString(IntToStr(Month), 2) + '.' +
   ZeroString(IntToStr(Year), 4) + ' ' +
   ZeroString(IntToStr(Hour), 2) + ':' +
   ZeroString(IntToStr(Min), 2) + ':' +
   ZeroString(IntToStr(Sec), 2));
   If Ext = 'ZIP' then
    PutString(34, 3 + I, BC, 15, 'Zip Archive') Else
   If Ext = 'RAR' then
    PutString(34, 3 + I, BC, 15, 'Rar Archive') Else
   If Ext = 'GBA' then
    PutString(34, 3 + I, BC, 15, 'GameBoy Advance Rom') Else
   If Ext = 'GB' then
    PutString(34, 3 + I, BC, 15, 'GameBoy Rom') Else
   If Ext = 'GBC' then
    PutString(34, 3 + I, BC, 15, 'GameBoy Color Rom') Else
   If Ext = 'NES' then
    PutString(34, 3 + I, BC, 15, 'NES Rom') Else
   If Ext = 'SMC' then
    PutString(34, 3 + I, BC, 15, 'SNES Rom') Else
   If Ext = 'SMD' then
    PutString(34, 3 + I, BC, 15, 'Sega Genesis Rom') Else
   If Ext = 'BIN' then
    PutString(34, 3 + I, BC, 15, 'Binary File') Else
   If Ext = 'TXT' then
    PutString(34, 3 + I, BC, 15, 'Text File') Else
   If Ext = 'TBL' then
    PutString(34, 3 + I, BC, 15, 'Table File') Else
    PutString(34, 3 + I, BC, 15, Ext + ' File');
  end;
  Inc(K);
  N := Next;
  If N = NIL then Break;
 end;
end;

Constructor TDirMenu.Create;
begin
 Root := NIL;
 Cur := NIL;
 Count := 0;
 StateIndex := 0;
 ItemIndex := -1;
end;

Function TDirMenu.AddItem(FE: PFileEntry; D: Boolean): PDirMenuItem;
begin
 New(Result);
 If Root = NIL then
 begin
  Root := Result;
  Cur := Result;
 end Else
 begin
  Cur^.Next := Result;
  Cur := Result;
 end;
 With Result^ do
 begin
  FileEntry := FE;
  Dir := D;
  Next := NIL;
 end;
 Inc(Count);
end;

Function TDirMenu.GetItem(Index: Integer): PDirMenuItem;
Var I: Integer; N: PDirMenuItem;
begin
 N := Root; I := 0;
 While N <> NIL do
 begin
  If I = Index then
  begin
   Result := N;
   Exit;
  end;
  Inc(I);
  N := N^.Next;
 end;
 Result := NIL;
end;

Destructor TDirMenu.Destroy;
Var N: PDirMenuItem;
begin
 While Root <> NIL do
 begin
  N := Root^.Next;
  Dispose(Root);
  Root := N;
 end;
 Cur := NIL;
 Count := 0;
 StateIndex := 0;
 ItemIndex := -1;
end;

Function TFiles.GetItem(Index: Integer): PFileEntry;
Var I: Integer; N: PFileEntry;
begin
 N := Root; I := 0;
 While N <> NIL do
 begin
  If I = Index then
  begin
   Result := N;
   Exit;
  end;
  Inc(I);
  N := N^.Next;
 end;
 Result := NIL;
end;

Constructor TFiles.Init;
begin
 Root := NIL;
 Count := 0;
end;

Function TFiles.Add: PFileEntry;
begin
 New(Result);
 FillChar(Result^, SizeOf(TFileEntry), 0);
 Result^.Next := Root;
 Root := Result;
 Inc(Count);
end;

Procedure TFiles.Sort(How: Integer);
Procedure NameSort(L, R: Integer);
Var
 I, J: Integer; N, M, X: PFileEntry;
 Y: TFileEntry;
begin
 I := L; J := R; X := GetItem((L + R) div 2);
 Repeat
  While GetItem(I)^.Name < X^.Name do Inc(I);
  While X^.Name < GetItem(J)^.Name do Dec(J);
  If I <= J then
  begin
   N := GetItem(I);
   M := GetItem(J);
   Move(N^, Y,  SizeOf(TFileEntry) - 4);
   Move(M^, N^, SizeOf(TFileEntry) - 4);
   Move(Y,  M^, SizeOf(TFileEntry) - 4);
   Inc(I); Dec(J);
  end;
 Until I > J;
 If L < J then NameSort(L, J);
 If I < R then NameSort(I, R);
end;
Procedure TypeSort(L, R: Integer);
Var
 I, J: Integer; N, M, X: PFileEntry;
 Y: TFileEntry;
begin
 I := L; J := R; X := GetItem((L + R) div 2);
 Repeat
  While GetItem(I)^.Ext < X^.Ext do Inc(I);
  While X^.Ext < GetItem(J)^.Ext do Dec(J);
  If I <= J then
  begin
   N := GetItem(I);
   M := GetItem(J);
   Move(N^, Y,  SizeOf(TFileEntry) - 4);
   Move(M^, N^, SizeOf(TFileEntry) - 4);
   Move(Y,  M^, SizeOf(TFileEntry) - 4);
   Inc(I); Dec(J);
  end;
 Until I > J;
 If L < J then TypeSort(L, J);
 If I < R then TypeSort(I, R);
end;
Procedure SizeSort(L, R: Integer);
Var
 I, J: Integer; N, M, X: PFileEntry;
 Y: TFileEntry;
begin
 I := L; J := R; X := GetItem((L + R) div 2);
 Repeat
  While GetItem(I)^.Size < X^.Size do Inc(I);
  While X^.Size < GetItem(J)^.Size do Dec(J);
  If I <= J then
  begin
   N := GetItem(I);
   M := GetItem(J);
   Move(N^, Y,  SizeOf(TFileEntry) - 4);
   Move(M^, N^, SizeOf(TFileEntry) - 4);
   Move(Y,  M^, SizeOf(TFileEntry) - 4);
   Inc(I); Dec(J);
  end;
 Until I > J;
 If L < J then SizeSort(L, J);
 If I < R then SizeSort(I, R);
end;
Procedure DateSort(L, R: Integer);
Var
 I, J: Integer; N, M, X: PFileEntry;
 Y: TFileEntry;
begin
 I := L; J := R; X := GetItem((L + R) div 2);
 Repeat
  While GetItem(I)^.Date < X^.Date do Inc(I);
  While X^.Date < GetItem(J)^.Date do Dec(J);
  If I <= J then
  begin
   N := GetItem(I);
   M := GetItem(J);
   Move(N^, Y,  SizeOf(TFileEntry) - 4);
   Move(M^, N^, SizeOf(TFileEntry) - 4);
   Move(Y,  M^, SizeOf(TFileEntry) - 4);
   Inc(I); Dec(J);
  end;
 Until I > J;
 If L < J then DateSort(L, J);
 If I < R then DateSort(I, R);
end;
begin
 Case How of
  ByName: NameSort(0, Count - 1);
  ByType: TypeSort(0, Count - 1);
  BySize: SizeSort(0, Count - 1);
  ByDate: DateSort(0, Count - 1);
 end;
end;

Destructor TFiles.Done;
Var N: PFileEntry;
begin
 While Root <> NIL do
 begin
  N := Root^.Next;
  Dispose(Root);
  Root := N;
 end;
 Count := 0;
end;

Const
 Title = 'Hexposure File Selector v1.666 by Djinn';

Var
 Dirs: PFiles := NIL;
 Files: PFiles := NIL;
 DirMenu: PDirMenu := NIL;
 DirectoryString: String;

Procedure DrawDirectory;
Var B: Integer;
begin
 For B := 1 to 80 do PutChar(B, 25, 7, 0, ' ');
 PutString(2, 25, 7, 0, DirectoryString + FiltX);
end;

Procedure DrawInterface;
Var I, B, X, Y, W, H, Left, Top, Background, Color: Integer;
begin
 B := (80 - Length(Title)) div 2;
 For I := 1 to 80 do
 begin
  If (I > B) and (I <= B + Length(Title)) then
   PutChar(I, 1, 7, 0, Title[I - B]) Else
   PutChar(I, 1, 7, 0, ' ');
 end;
 W := 79;
 H := 22;
 Left := 1;
 Top := 2;
 Background := 0;
 Color := 1;
 For Y := 0 to H do
  For X := 0 to W do
   If (X + Left > 0) and (X + Left <= 80) and (Y + Top > 0) and (Y + Top <= 25) then
   begin
    If (Y = 0) and (X = 0) then
     PutChar(X + Left, Y + Top, Background, Color, #218) Else
    If ((Y = 0) or (Y = H)) and (X > 0) and (X < W) then
     PutChar(X + Left, Y + Top, Background, Color, #196) Else
    If (Y = 0) and (X = W) then
     PutChar(X + Left, Y + Top, Background, Color, #191) Else
    If (Y > 0) and (Y < H) and ((X = 0) or (X = W)) then
     PutChar(X + Left, Y + Top, Background, Color, #179) Else
    If (Y = H) and (X = 0) then
     PutChar(X + Left, Y + Top, Background, Color, #192) Else
    If (Y = H) and (X = W) then
     PutChar(X + Left, Y + Top, Background, Color, #217) Else
     PutChar(X + Left, Y + Top, Background, Color, ' ');
   end;
 PutChar(1, 2, 0, 15, Buffer^[2, 1].Chr);
 PutChar(80, 2, 0, 15, Buffer^[2, 80].Chr);
 PutChar(1, 24, 0, 15, Buffer^[24, 1].Chr);
 PutChar(80, 24, 0, 15, Buffer^[24, 80].Chr);
 PutChar(1, 3, 0, 11, Buffer^[3, 1].Chr);
 PutChar(2, 2, 0, 11, Buffer^[2, 2].Chr);
 PutChar(3, 2, 0, 11, Buffer^[2, 3].Chr);
 PutChar(79, 2, 0, 11, Buffer^[2, 79].Chr);
 PutChar(78, 2, 0, 11, Buffer^[2, 78].Chr);
 PutChar(2, 24, 0, 11, Buffer^[24, 2].Chr);
 PutChar(3, 24, 0, 11, Buffer^[24, 3].Chr);
 PutChar(79, 24, 0, 11, Buffer^[24, 79].Chr);
 PutChar(78, 24, 0, 11, Buffer^[24, 78].Chr);
 PutChar(80, 3, 0, 11, Buffer^[3, 80].Chr);
 PutChar(1, 23, 0, 11, Buffer^[23, 1].Chr);
 PutChar(80, 23, 0, 11, Buffer^[23, 80].Chr);
 PutChar(1, 4, 0, 9, Buffer^[4, 1].Chr);
 PutChar(4, 2, 0, 9, Buffer^[2, 4].Chr);
 PutChar(5, 2, 0, 9, Buffer^[2, 4].Chr);
 PutChar(4, 24, 0, 9, Buffer^[24, 4].Chr);
 PutChar(5, 24, 0, 9, Buffer^[24, 4].Chr);
 PutChar(77, 2, 0, 9, Buffer^[2, 77].Chr);
 PutChar(76, 2, 0, 9, Buffer^[2, 76].Chr);
 PutChar(77, 24, 0, 9, Buffer^[24, 77].Chr);
 PutChar(76, 24, 0, 9, Buffer^[24, 76].Chr);
 PutChar(80, 4, 0, 9, Buffer^[4, 80].Chr);
 PutChar(1, 22, 0, 9, Buffer^[22, 1].Chr);
 PutChar(80, 22, 0, 9, Buffer^[22, 80].Chr);
 DrawDirectory;
end;

Function CDTest(Drive: Char): Boolean;
Var Regs: Registers;
begin
 Result := False;
 FillChar(Regs, SizeOf(Regs), 0);
 Regs.CX := Ord(Drive) - Ord('A');
 Regs.AX := $150B;
 Intr($2F, Regs);
 Result := (IOResult = 0) and (Regs.AX <> 0) and (Regs.BX = $ADAD);
end;

Function DiskTest(Drive: Char): Boolean;
Var Regs: Registers; D: String;
begin
 Result := False;
 System.GetDir(0, D);
 {$I-}
 ChDir(Drive + ':');
 {$I+}
 If IOResult = 0 then
 begin
  ChDir(D);
  Result := True;
 end;
end;

Var
 Error: Boolean;

Procedure UserExit;
begin
 Error := ExitCode <> 0;
 ExitCode := 0;
 ErrorAddr := NIL;
end;

Var
 OldExit: Pointer;

Procedure CreateDiskList;
Var I: Char;
begin
 OldExit := ExitProc;
 ExitProc := Addr(UserExit);
 New(Dirs, Init);
 New(Files, Init);
 With Dirs^.Add^ do
 begin
  Name := '[A:]';
  Ext := '';
  Date := 0;
  Size := 0;
  DiskSel := True;
 end;
 Error := False;
 For I := 'C' to 'Z' do
 begin
  If not CDTest(I) and DiskTest(I) and not Error then With Dirs^.Add^ do
  begin
   Error := False;
   Name := '[' + I + ':]';
   Ext := '';
   Date := 0;
   {$I-}
   Size := DiskSize(Ord(I) - Ord('A'));
   {$I+}
   DiskSel := True;
  end;
 end;
 Dirs^.Sort(ByName);
 ExitProc := OldExit;
end;

Procedure CreateFileList(Filter: String; SortHow: Integer);
Var
 SR: SearchRec; D: DirStr; F: NameStr; E: ExtStr;
 RootDir: Boolean;
begin
 New(Dirs, Init);
 New(Files, Init);
 FindFirst('*.*', Directory, SR);
 RootDir := True;
 While DosError = 0 do
 begin
  If (SR.Name <> '.') and (SR.Name <> '..') and
     (SR.Attr = Directory) then
  With Dirs^.Add^ do
  begin
   FSplit(SR.Name, D, F, E);
   Name := F;
   Delete(E, 1, 1);
   Ext := E;
   Date := DWord(SR.Time);
   Size := 0;
  end;
  FindNext(SR);
 end;
 Dirs^.Sort(ByName);
 FindFirst('*.*', AnyFile, SR);
 While DosError = 0 do
 begin
  If SR.Name = '..' then With Dirs^.Add^ do
  begin
   Name := '..';
   Ext := '';
   Date := SR.Time;
   Size := 0;
  end;
  FindNext(SR);
 end;
 If Dirs^.Root^.Name <> '..' then
 With Dirs^.Add^ do
 begin
  Name := '..';
  Ext := '';
  Date := SR.Time;
  Size := 0;
  DiskSel := True;
 end;
 FindFirst(Filter, Archive, SR);
 While DosError = 0 do
 begin
  If SR.Attr and ReadOnly <> 1 then
  With Files^.Add^ do
  begin
   FSplit(SR.Name, D, F, E);
   Name := F;
   Delete(E, 1, 1);
   Ext := E;
   Date := DWord(SR.Time);
   Size := SR.Size;
  end;
  FindNext(SR);
 end;
 Files^.Sort(SortHow);
end;

Procedure DestroyFileList;
begin
 Dispose(Files, Done);
 Dispose(Dirs, Done);
end;

Procedure CreateMenu;
Var N: PFileEntry;
begin
 New(DirMenu, Create);
 N := Dirs^.Root;
 If N <> NIL then DirMenu^.ItemIndex := 0;
 With DirMenu^ do While N <> NIL do
 begin
  AddItem(N, True);
  N := N^.Next;
 end;
 N := Files^.Root;
 If N <> NIL then DirMenu^.ItemIndex := 0;
 With DirMenu^ do While N <> NIL do
 begin
  AddItem(N, False);
  N := N^.Next;
 end;
 DirMenu^.Draw;
end;

Procedure DestroyMenu;
begin
 Dispose(DirMenu, Destroy);
end;

Function DirItemIndex: Integer;
Var I: Integer; S, Nm: String[12]; N: PDirMenuItem;
begin
 I := Length(DirectoryString) - 1;
 S := '';
 While DirectoryString[I] <> '\' do
 begin
  S := DirectoryString[I] + S;
  Dec(I);
 end;
 Result := -1;
 I := 0;
 N := DirMenu^.Root;
 While N <> NIL do
 begin
  With N^.FileEntry^ do
  begin
   Nm := Name;
   If Ext <> '' then Nm := Name + '.' + Ext;
  end;
  If Nm = S then
  begin
   Result := I;
   Break;
  end;
  Inc(I);
  N := N^.Next;
 end;
end;

Procedure GetDir;
begin
 System.GetDir(0, DirectoryString);
 If DirectoryString[Length(DirectoryString)] <> '\' then
  DirectoryString := DirectoryString + '\';
end;

Function FileSelect(Filter: String): String;
Var Nm, DirStr: String;
begin
 FiltX := UpperCase(Filter);
 FillChar(Buffer^, SizeOf(TTextData), 0);
 GetDir;
 DirStr := DirectoryString;
 DrawInterface;
 CreateFileList(Filter, ByName);
 CreateMenu;
 ShowBuffer;
 Result := '';
 Repeat
  If KPressed then
  Case KurKey of
   Esc_Scan: Break;
   Down_Scan: With DirMenu^ do If ItemIndex >= 0 then
   begin
    Inc(ItemIndex);
    If ItemIndex = Count then Dec(ItemIndex);
    If ItemIndex - StateIndex > 20 then Inc(StateIndex);
    Draw;
    ShowBuffer;
    KPressed := False;
   end;
   PgDn_Scan: With DirMenu^ do If ItemIndex >= 0 then
   begin
    Inc(ItemIndex, 21);
    If ItemIndex >= Count then ItemIndex := Count - 1;
    While ItemIndex - StateIndex > 20 do Inc(StateIndex);
    Draw;
    ShowBuffer;
    KPressed := False;
   end;
   PgUp_Scan: With DirMenu^ do If ItemIndex >= 0 then
   begin
    Dec(ItemIndex, 21);
    If ItemIndex < 0 then ItemIndex := 0;
    While ItemIndex - StateIndex < 0 do Dec(StateIndex);
    Draw;
    ShowBuffer;
    KPressed := False;
   end;
   Up_Scan: With DirMenu^ do If ItemIndex >= 0 then
   begin
    Dec(ItemIndex);
    If ItemIndex < 0 then ItemIndex := 0;
    If ItemIndex - StateIndex < 0 then Dec(StateIndex);
    Draw;
    ShowBuffer;
    KPressed := False;
   end;
   Home_Scan: With DirMenu^ do If ItemIndex >= 0 then
   begin
    StateIndex := 0;
    ItemIndex := 0;
    Draw;
    ShowBuffer;
    KPressed := False;
   end;
   End_Scan: With DirMenu^ do If ItemIndex >= 0 then
   begin
    ItemIndex := Count - 1;
    While ItemIndex - StateIndex > 20 do Inc(StateIndex);
    Draw;
    ShowBuffer;
    KPressed := False;
   end;
   Back_Scan: With DirMenu^ do If Count > 0 then With GetItem(0)^ do
   begin
    Nm := FileEntry^.Name;
    If Nm = '..' then
    begin
     If not FileEntry^.DiskSel then
     begin
      {$I-}
      ChDir(Nm);
      {$I+}
      If IOResult = 0 then
      begin
       DestroyMenu;
       DestroyFileList;
       CreateFileList(Filter, ByName);
       CreateMenu;
       If Nm = '..' then With DirMenu^ do
       begin
        ItemIndex := DirItemIndex;
        If ItemIndex < 0 then ItemIndex := 0 Else
        While ItemIndex - StateIndex > 20 do Inc(StateIndex);
        Draw;
       end;
       GetDir;
       DrawDirectory;
       ShowBuffer;
      end;
     end Else
     begin
      DestroyMenu;
      DestroyFileList;
      CreateDiskList;
      CreateMenu;
      DirectoryString := '';
      DrawDirectory;
      ShowBuffer;
     end;
    end;
    KPressed := False;
   end;
   Ent_Scan: With DirMenu^ do If ItemIndex >= 0 then With GetItem(ItemIndex)^ do
   begin
    If Dir then
    begin
     If not FileEntry^.DiskSel then
     begin
      With FileEntry^ do
      begin
       Nm := Name;
       If Ext <> '' then Nm := Nm + '.' + Ext;
      end;
      {$I-}
      ChDir(Nm);
      {$I+}
      If IOResult = 0 then
      begin
       DestroyMenu;
       DestroyFileList;
       CreateFileList(Filter, ByName);
       CreateMenu;
       If Nm = '..' then With DirMenu^ do
       begin
        ItemIndex := DirItemIndex;
        If ItemIndex < 0 then ItemIndex := 0 Else
        While ItemIndex - StateIndex > 20 do Inc(StateIndex);
        Draw;
       end;
       GetDir;
       DrawDirectory;
       ShowBuffer;
      end;
     end Else
     begin
      With FileEntry^ do  Nm := Name;
      If Nm = '..' then
      begin
       DestroyMenu;
       DestroyFileList;
       CreateDiskList;
       CreateMenu;
       DirectoryString := '';
       DrawDirectory;
       ShowBuffer;
      end Else
      begin
       {$I-}
       ChDir(Nm[2] + Nm[3]);
       {$I+}
       If IOResult = 0 then
       begin
        DestroyMenu;
        DestroyFileList;
        CreateFileList(Filter, ByName);
        CreateMenu;
        GetDir;
        DrawDirectory;
        ShowBuffer;
       end;
      end;
     end;
    end Else
    begin
     With FileEntry^ do
     begin
      Nm := Name;
      If Ext <> '' then Nm := Nm + '.' + Ext;
     end;
     If FileExists(Nm) then
     begin
      Result := Nm;
      Break;
     end;
    end;
    KPressed := False;
   end;
  end;
 Until False;
 DestroyMenu;
 DestroyFileList;
 KPressed := False;
 Dec(Byte(DirStr[0]));
 If Result = '' then ChDir(DirStr);
end;

end.