Program Hexpose;

Uses Crt, Use32, Strings, KeyBoard, Dos, Needs, FileSel;

Var
 Int09Save: FarPointer;
 ANSIMode: Boolean = False;

Procedure KeyboardOn(Handler: Pointer);
begin
 GetIntVec($09, Int09Save);
 SetIntVec($09, Handler);
end;

Procedure KeyboardOff;
begin
 SetIntVec($09, Int09Save);
end;

Const
 Menu: String[43] = '  File  Tables  Edit  Search  Help';
 Title = 'Hexposure v3.666 by Djinn';

Function AnsiToAscii(Ch: Char): Char;
begin
 Case Ch of
  #192..#239: Result := Char(Byte(Ch) - $40);
  #240..#255: Result := Char(Byte(Ch) - $10);
        #168: Result := #240;
        #184: Result := #241;
  Else        Result := Ch;
 end;
end;

Function AsciiToAnsi(Ch: Char): Char;
begin
 Case Ch of
  #128..#175: Result := Char(Byte(Ch) + $40);
  #224..#239: Result := Char(Byte(Ch) + $10);
        #240: Result := #168;
        #241: Result := #184;
  Else        Result := Ch;
 end;
end;

Type
 PTableElement = ^TTableElement;
 TTableElement = Record
  Character: String[2];
  ColorCode: Byte;
  HexCode: Byte;
  Next: PTableElement;
 end;
 PTable = ^TTable;
 TTable = Object
  Root, Cur: PTableElement;
  Count: Integer;
  Constructor Init;
  Procedure Load(FileName: String);
  Function Save(FileName: String): Boolean;
  Function Add(Hex: Byte; Char: String; Color: Byte): PTableElement;
  Function GetCharacter(Hex: Byte; var Color: Byte): String;
  Function GetCode(Char: String): Integer;
  Destructor Done;
 end;
 TProcess = Procedure (X: Pointer);
 PComponent = ^TComponent;
 TComponent = Record
  Owner: Pointer;
  Left: Integer;
  Top: Integer;
  Width: Integer;
  Enabled: Boolean;
  Cursor: Integer;
  Background: Byte;
  Color: Byte;
  Text: String;
  Process: TProcess;
  Next: PComponent;
 end;
 PComponents = ^TComponents;
 TComponents = Object
  Root, Cur: PComponent;
  Count, ItemIndex: Integer;
  Constructor Init;
  Function Add(S: String; X, Y, W, B, C: Integer; Proc: TProcess): PComponent;
  Function GetComponent(Index: Integer): PComponent;
  Procedure Draw;
  Destructor Done;
 end;
 PWindow = ^TWindow;
 TWindow = Object
  Caption: String;
  Left: Integer;
  Top: Integer;
  Width: Integer;
  Height: Integer;
  Background: Byte;
  Color: Byte;
  Components: PComponents;
  Constructor Create(S: String; X, Y, W, H, B, C: Integer);
  Procedure Show;
  Procedure Hide;
  Destructor Destroy;
 end;
 TKeyComb = Record
  Ctrl: Boolean;
  Alt: Boolean;
  Shift: Boolean;
  Key: Byte;
 end;
 PMenuItem = ^TMenuItem;
 TMenuItem = Record
  Caption: String;
  Checked: Boolean;
  KeyComb: TKeyComb;
  Separator: Boolean;
  Enabled: Boolean;
  Command: Integer;
  Next: PMenuItem;
 end;
 PMenu = ^TMenu;
 TMenu = Object
  Window: PWindow;
  Root, Cur: PMenuItem;
  Count, ItemIndex: Integer;
  Constructor Create(X, Y, B, C: Integer);
  Function AddItem(S: String; Alt, Ctrl, Shift: Boolean; Key: Byte; Com: Integer): PMenuItem;
  Function GetItem(Index: Integer): PMenuItem;
  Procedure Show;
  Procedure Hide;
  Destructor Destroy;
 end;

Function TTable.Save(FileName: String): Boolean;
Var F: Text; N: PTableElement; AS: String[2]; I: Integer;
begin
 If FileName[Length(FileName)] = '.' then Dec(Byte(FileName[0]));
 Assign(F, FileName);
 {$I-}
 Rewrite(F);
 {$I+}
 If IOResult = 0 then
 begin
  Result := True;
  N := Root;
  While N <> NIL do With N^ do
  begin
   AS := Character;
   If AnsiMode then For I := 1 to Length(AS) do
    AS[I] := AsciiToAnsi(AS[I]);
   If Character = #25 then
    Writeln(F, '*=' + IntToHex(HexCode, 2)) Else
   If Character = #254 then
    Writeln(F, '/=' + IntToHex(HexCode, 2)) Else
   If (ColorCode = LightRed) or (ColorCode = LightCyan) then
    Writeln(F, AS + '=' + IntToHex(HexCode, 2)) Else
    Writeln(F, IntToHex(HexCode, 2) + '=' + AS);
   N := Next;
  end;
  Close(F);
 end Else Result := False;
end;

Procedure TTable.Load(FileName: String);
Var F: Text; S: String; Hex: String[2];
begin
 Assign(F, FileName);
 Reset(F);
 While not EOF(F) do
 begin
  Readln(F, S);
  If (Length(S) >= 4) and
     (UpCase(S[1]) in ['0'..'9', 'A'..'F']) and
     (UpCase(S[2]) in ['0'..'9', 'A'..'F']) and
     (S[3] = '=') then
  begin
   Hex := S[1] + S[2];
   Delete(S, 1, 3);
   If Length(S) >= 2 then
   begin
    Byte(S[0]) := 2;
    If ANSIMode then
    begin
     S[1] := AnsiToAscii(S[1]);
     S[2] := AnsiToAscii(S[2]);
    end;
   end Else If AnsiMode then S[1] := AnsiToAscii(S[1]);
   If Byte(S[0]) = 2 then
    Add(HexVal(Hex), S, Yellow) Else
    Add(HexVal(Hex), S, White);
  end Else If (Length(S) = 4) and //(S[1] in ['*', '/']) and (S[2] = '=') and
              (UpCase(S[3]) in ['0'..'9', 'A'..'F']) and
              (UpCase(S[4]) in ['0'..'9', 'A'..'F']) then
  begin
   Hex := S[3] + S[4];
   If S[1] = '*' then
    Add(HexVal(Hex), #25, LightRed) Else
   If S[1] = '/' then
    Add(HexVal(Hex), #254, LightRed) Else
   begin
    If ANSIMode then
     Add(HexVal(Hex), AnsiToAscii(S[1]), LightCyan) Else
     Add(HexVal(Hex), S[1], LightCyan);
   end;
  end Else If (Length(S) = 3) and// (S[1] in ['*', '/']) and
              (UpCase(S[2]) in ['0'..'9', 'A'..'F']) and
              (UpCase(S[3]) in ['0'..'9', 'A'..'F']) then
  begin
   Hex := S[2] + S[3];
   If S[1] = '*' then
    Add(HexVal(Hex), #25, LightRed) Else
   If S[1] = '/' then
    Add(HexVal(Hex), #254, LightRed) Else
   begin
    If ANSIMode then
     Add(HexVal(Hex), AnsiToAscii(S[1]), LightCyan) Else
     Add(HexVal(Hex), S[1], LightCyan);
   end;
  end;
 end;
 Close(F);
end;

Constructor TComponents.Init;
begin
 Root := NIL;
 Cur := NIL;
 Count := 0;
 ItemIndex := -1;
end;

Function TComponents.GetComponent(Index: Integer): PComponent;
Var I: Integer; N: PComponent;
begin
 N := Root; I := 0;
 While N <> NIL do
 begin
  If I = Index then
  begin
   Result := N;
   Exit;
  end;
  Inc(I);
  N := N^.Next;
 end;
 Result := NIL;
end;

Procedure TComponents.Draw;
Var I, J: Integer; N: PComponent;
begin
 N := Root; J := 0;
 While N <> NIL do With N^ do
 begin
  For I := Left to Left + Width - 1 do
   PutChar(I, Top, Background, Color, ' ');
  PutString(Left, Top, Background, Color, Text);
  If ItemIndex = J then
  begin
   If Cursor >= 0 then
   begin
    ShowCursor;
    GotoXY(Left + Length(Text), Top);
   end Else HideCursor;
  end;
  Inc(J);
  N := Next;
 end;
end;

Function TComponents.Add(S: String; X, Y, W, B, C: Integer; Proc: TProcess): PComponent;
begin
 New(Result);
 If Root = NIL then
 begin
  Root := Result;
  Cur := Result;
 end Else
 begin
  Cur^.Next := Result;
  Cur := Result;
 end;
 Inc(Count);
 Result^.Owner := @Self;
 With Result^ do
 begin
  Left := X;
  Top := Y;
  Width := W;
  Background := B;
  Color := C;
  If Length(S) > W - 1 then S[0] := Char(W - 1);
  Text := S;
  Process := Proc;
  Enabled := True;
  Cursor := -1;
  Next := NIL;
 end;
end;

Destructor TComponents.Done;
Var N: PComponent;
begin
 While Root <> NIL do
 begin
  N := Root^.Next;
  Dispose(Root);
  Root := N;
 end;
 Cur := NIL;
 Count := 0;
 HideCursor;
end;

Function TTable.GetCode(Char: String): Integer;
Var N: PTableElement;
begin
 Result := -1;
 N := Root;
 While N <> NIL do With N^ do
 begin
  If Char = Character then
  begin
   Result := HexCode;
   Exit;
  end;
  N := Next;
 end;
end;

Var
 CharFind: Boolean := False;

Function TTable.GetCharacter(Hex: Byte; var Color: Byte): String;
Var N: PTableElement;
begin
 CharFind := False;
 Result := '.';
 Color := LightGray;
 N := Root;
 While N <> NIL do With N^ do
 begin
  If HexCode = Hex then
  begin
   CharFind := True;
   Result := Character;
   Color := ColorCode;
   Exit;
  end;
  N := Next;
 end;
end;

Constructor TTable.Init;
begin
 Root := NIL;
 Cur := NIL;
 Count := 0;
end;

Function TTable.Add(Hex: Byte; Char: String; Color: Byte): PTableElement;
Var N: PTableElement;
begin
 New(N);
 If Root = NIL then
 begin
  Root := N;
  Cur := N;
 end Else
 begin
  Cur^.Next := N;
  Cur := N;
 end;
 With N^ do
 begin
  Character := Char;
  HexCode := Hex;
  ColorCode := Color;
  Next := NIL;
 end;
 Result := N;
 Inc(Count);
end;

Destructor TTable.Done;
Var N: PTableElement;
begin
 While Root <> NIL do
 begin
  N := Root^.Next;
  Dispose(Root);
  Root := N;
 end;
 Cur := NIL;
 Count := 0;
end;

Var
 Rom: PBytes;
 RomSize: DWord;
 Pages: Integer;
 CurRomByte: PByte;
 CurPage: Integer;
 Row, Col: Integer;
 Tables: Array[0..3] of PTable;
 Menus: Array[0..4] of PMenu;
 Table: PTable := NIL;
 HexEdit: Boolean := True;
 CharsOnLine: Byte := 16;

Procedure CreateAnsiTable(Index: Integer);
Var I: Char;
begin
 If Index < 0 then Exit; If Index > 3 then Exit;
 If Tables[Index] <> NIL then Dispose(Tables[Index], Done);
 New(Tables[Index], Init);
 With Tables[Index]^ do
 begin
  For I := ' ' to '' do Add(Byte(I), I, White);
  Add($0A, #25, LightRed);
  Add($00, #254, LightRed);
  For I := '' to '' do Add(Byte(I), AnsiToAscii(I), White);
  Add(Byte(''), '', White);
  Add(Byte(''), '', White);
 end;
end;

Procedure CreateAsciiTable(Index: Integer);
Var I: Char;
begin
 If Index < 0 then Exit; If Index > 3 then Exit;
 If Tables[Index] <> NIL then Dispose(Tables[Index], Done);
 New(Tables[Index], Init);
 With Tables[Index]^ do
 begin
  For I := ' ' to '' do Add(Byte(I), I, White);
  Add($0A, #25, LightRed);
  Add($00, #254, LightRed);
  For I := #128 to #175 do Add(Byte(I), I, White);
  For I := #224 to #241 do Add(Byte(I), I, White);
 end;
end;

Procedure FreeTables;
Var I: Integer;
begin
 For I := 0 to 3 do If Tables[I] <> NIL then Dispose(Tables[I], Done);
 FillChar(Tables, SizeOf(Tables), 0);
end;

Procedure DrawPageStarts;
Var Y: Integer;
begin
 For Y := 0 to 15 do
  PutString(3, Y + 3, Black, White, IntToHex((CurPage + Y) * 16, 8));
end;

Procedure DrawOfs;
begin
 PutString(7, 20, Black, White, IntToHex((CurPage + Row) * 16 + Col, 8));
end;

Procedure DrawEnd;
begin
 PutString(7, 21, Black, White, IntToHex(RomSize - 1, 8));
end;

Procedure DrawPercent;
begin
 PutString(16, 20, Black, White,
 ZeroString(IntToStr((DWord((CurPage + Row) * 16 + Col) * 100) div (RomSize - 1)), 3) + '%');
end;

Procedure DrawRow;
begin
 PutString(25, 20, Black, White, IntToHex(Row, 2));
end;

Procedure DrawCol;
begin
 PutString(25, 21, Black, White, IntToHex(Col, 2));
end;

Procedure DrawHex;
begin
 PutString(33, 20, Black, White, IntToHex(CurRomByte^, 2));
end;

Procedure DrawDec;
begin
 PutString(33, 21, Black, White, ZeroString(IntToStr(CurRomByte^), 3));
end;

Procedure DrawRusType; Forward;

Function IntToBin(Value, Digits: DWord): String;
Var Mask, I: DWord;
begin
 Result := '';
 If Digits > 32 then Digits := 32;
 Mask := 1 shl (Digits - 1);
 For I := 1 to Digits do
 begin
  If Value and Mask = 0 then Result := Result + '0' Else Result := Result + '1';
  Mask := Mask shr 1;
 end;
end;

Procedure DrawBin;
begin
 PutString(42, 20, Black, White, IntToBin(CurRomByte^, 8));
end;

Var
 Second: Boolean := False;

Procedure DrawData;
Var X, Y: Integer; CurByte: PByte; S: String;
begin
 CurByte := Addr(Rom^[CurPage * 16]);
 While (CurPage + Row) * 16 + Col >= RomSize do
 begin
  Dec(Col);
  If Col < 0 then
  begin
   Col := 15;
   Dec(Row);
   If Row < 0 then Exit;
  end;
 end;
 For Y := 0 to 15 do
  For X := 0 to 15 do
  begin
   If (CurPage + Y) * 16 + X >= RomSize then Exit;
   S := IntToHex(CurByte^, 2);
   If not Odd(X) then
    PutString(13 + X * 2, 3 + Y, Byte((X = Col) or (Y = Row)) * Blue, White, S) Else
    PutString(13 + X * 2, 3 + Y, Byte((X = Col) or (Y = Row)) * Blue, LightCyan, S);
   If (X = Col) and (Y = Row) then
   begin
    PutChar(13 + X * 2 + Byte(Second), 3 + Y, 15 * Byte(HexEdit) + LightGray * Byte(not HexEdit), Black, S[1 + Byte(Second)]);
    CurRomByte := CurByte;
   end;
   Inc(DWord(CurByte));
  end;
end;

Procedure DrawText;
Var XX, X, Y: Integer; CurByte: PByte; S: String; Color: Byte;
begin
 CurByte := Addr(Rom^[CurPage * 16]);
 With Table^ do For Y := 0 to 15 do
 begin
  XX := 0;
  For X := 0 to 15 do
  begin
   If (CurPage + Y) * 16 + X >= RomSize then
   begin
    If Y = Row then CharsOnLine := XX;
    Exit;
   end;
   S := GetCharacter(CurByte^, Color);
   If (X = Col) and (Y = Row) then
   begin
//    If Length(S) = 1 then
     PutString(47 + XX, 3 + Y, 15 * Byte(not HexEdit) + LightGray * Byte(HexEdit), Black, S);// Else
//     PutString(47 + XX, 3 + Y, 15 * Byte(not HexEdit) + LightGray * Byte(HexEdit), Black, S);
   end Else
   begin
//    If Length(S) = 1 then
     PutString(47 + XX, 3 + Y, Black, Color, S);// Else
//     PutString(47 + XX, 3 + Y, Black, Yellow, S);
   end;
   Inc(XX, Length(S));
   Inc(DWord(CurByte));
  end;
  If Y = Row then CharsOnLine := XX;
 end;
end;

Procedure DrawCONL;
begin
 PutString(66, 20, Black, White, ZeroString(IntToStr(CharsOnLine), 2));
end;

Procedure ClearHexAndText;
Var X, Y: Integer;
begin
 For Y := 3 to 18 do For X := 13 to 44 do PutChar(X, Y, Black, White, ' ');
 For Y := 3 to 18 do For X := 47 to 78 do PutChar(X, Y, Black, White, ' ');
end;

Procedure DrawAll;
begin
 DrawPageStarts;
 ClearHexAndText;
 DrawData;
 DrawText;
 DrawOfs;
 DrawEnd;
 DrawPercent;
 DrawRow;
 DrawCol;
 DrawHex;
 DrawDec;
 DrawBin;
 DrawCONL;
 DrawRusType;
end;

Var
 FileName: String;

Procedure DrawInterface;
Var I, B: Integer;
begin
 For I := 1 to Length(Menu) do PutChar(I, 1, 7, 0, Menu[I]);
 For I := Length(Menu) + 1 to 80 do PutChar(I, 1, 7, 0, ' ');
 PutChar(78, 1, 7, 0, ']');
 B := 77;
 For I := Length(FileName) downto 1 do
 begin
  PutChar(B, 1, 7, 0, FileName[I]);
  Dec(B);
  If B < Length(Menu) + 7 then
  begin
   PutString(Length(Menu) + 3, 1, 7, 0, '[...');
   Break;
  end Else If I = 1 then PutChar(B, 1, 7, 0, '[');
 end;
 B := (80 - Length(Title)) div 2;
 For I := 1 to 80 do
 begin
  If (I > B) and (I <= B + Length(Title)) then
   PutChar(I, 25, 7, 0, Title[I - B]) Else
   PutChar(I, 25, 7, 0, ' ');
 end;
 For I := 2 to 24 do For B := 1 to 80 do PutChar(B, I, Blue, DarkGray, '');
 DrawAll;
 PutString( 3, 20, Black, White, 'Ofs');
 PutString( 3, 21, Black, White, 'End');
 PutString(21, 20, Black, White, 'Row');
 PutString(21, 21, Black, White, 'Col');
 PutString(29, 20, Black, White, 'Hex');
 PutString(29, 21, Black, White, 'Dec');
 PutString(38, 20, Black, White, 'Bin');
 PutString(52, 20, Black, White, 'Chars on line');
end;

Procedure MoveDown;
begin
 Inc(Row);
 If Row > 15 then
 begin
  Row := 15;
  Inc(CurPage);
  If CurPage > Pages - $10 then
  begin
   CurPage := Pages - $10;
   If CurPage < 0 then CurPage := 0;
  end;
 end;
end;

Procedure MoveUp;
begin
 Dec(Row);
 If Row < 0 then
 begin
  Row := 0;
  Dec(CurPage);
  If CurPage < 0 then CurPage := 0;
 end;
end;

Procedure MoveRight;
begin
 If (CurPage + Row) * 16 + Col = RomSize - 1 then Exit;
 Inc(Col);
 If Col > 15 then
 begin
  Col := 0;
  MoveDown;
 end;
end;

Procedure MoveLeft;
begin
 Dec(Col);
 If Col < 0 then
 begin
  If (CurPage = 0) and (Row = 0) then
  begin
   Col := 0;
   Exit;
  end;
  Col := 15;
  MoveUp;
 end;
end;

Var
 RusType: Boolean := False;

Procedure DrawRusType;
begin
 If CapsState then
 begin
  If RusType then
   PutString(3, 25, 7, 0, 'RUS') Else
   PutString(3, 25, 7, 0, 'LAT');
 end Else
 begin
  If RusType then
   PutString(3, 25, 7, 0, 'rus') Else
   PutString(3, 25, 7, 0, 'lat');
 end;
end;

Const
 Symbs: Array [Boolean, 0..57] of Char = (
    #0#0'1234567890-='#8#9'qwertyuiop[]'#13#0'asdfghjkl;''`'#0'\'+
    'zxcvbnm,./'#0'*'#0' ',
    #0#0'1234567890-='#8#9'㪥'#13#0'뢠஫'#0'\'+
    'ᬨ.'#0'*'#0' ');
 ShiftSymbs: Array [Boolean, 0..57] of Char = (
    #0#0'!@#$%^&*()_+'#8#9'QWERTYUIOP{}'#13#0'ASDFGHJKL:"~'#0'|'+
    'ZXCVBNM<>?'#0'*'#0' ',
    #0#0'!"#;%:?*()_+'#8#9''#13#0''#0'\'+
    ','#0'*'#0' ');
 Numbers: Array[0..12] of Char = '789-456+1230.';

Var
 PrevSystemKey: Boolean = False;
 SystemKey: Boolean = False;

Procedure KeyboardHandler; Interrupt;
begin
 KurKey := Port[$60];
 If KurKey = Caps_Scan then CapsState := not CapsState Else
 If KurKey = Num_Scan then NumState := not NumState Else
 If KurKey = Ctrl_Scan then CtrlPressed := True Else If KurKey = Ctrl_Scan + 128 then CtrlPressed := False Else
 If KurKey = Alt_Scan then AltPressed := True Else If KurKey = Alt_Scan + 128 then AltPressed := False Else
 If KurKey in [Lsh_Scan, Rsh_Scan] then ShiftPressed := True Else
 If KurKey in [LSh_Scan + 128, RSh_Scan + 128] then ShiftPressed := False;
 If KurKey < 128 then KPressed := True Else KPressed := False;
 SystemKey := PrevSystemKey or (KurKey in [Esc_Scan, Tab_Scan]);
 If SystemKey and (KurKey in [Ent_Scan, Back_Scan]) then SystemKey := False;
 PrevSystemKey := KurKey = 224;
 Port[$20] := $20;
end;

Constructor TWindow.Create(S: String; X, Y, W, H, B, C: Integer);
Var I: Integer;
begin
 Caption := S;
 Left := X;
 Top := Y;
 If W < 2 then W := 2;
 If H < 2 then H := 2;
 Width := W;
 Height := H;
 W := W + 1;
 H := H + 1;
 Background := B;
 Color := C;
 Components := NIL;
end;

Procedure TWindow.Show;
Var X, Y, W, H: Integer; S: String;
begin
 Hide;
 W := Width - 1;
 H := Height - 1;
 For Y := 0 to H do
  For X := 0 to W do
   If (X + Left > 0) and (X + Left <= 80) and (Y + Top > 0) and (Y + Top <= 25) then
   begin
    If (Y = 0) and (X = 0) then
     PutChar(X + Left, Y + Top, Background, Color, #218) Else
    If ((Y = 0) or (Y = H)) and (X > 0) and (X < W) then
     PutChar(X + Left, Y + Top, Background, Color, #196) Else
    If (Y = 0) and (X = W) then
     PutChar(X + Left, Y + Top, Background, Color, #191) Else
    If (Y > 0) and (Y < H) and ((X = 0) or (X = W)) then
     PutChar(X + Left, Y + Top, Background, Color, #179) Else
    If (Y = H) and (X = 0) then
     PutChar(X + Left, Y + Top, Background, Color, #192) Else
    If (Y = H) and (X = W) then
     PutChar(X + Left, Y + Top, Background, Color, #217) Else
     PutChar(X + Left, Y + Top, Background, Color, ' ');
   end;
 If Caption <> '' then
 begin
  S := '> ' + Caption + ' <';
  X := (Width - Length(S)) div 2;
  PutString(X + Left, Top, Background, Color, S);
 end;
 For X := Left + 1 to Left + Width do
  If (X > 0) and (X <= 80) and (Top + Height > 0) and (Top + Height <= 25) then
   PutChar(X, Top + Height, Black, DarkGray, Buffer^[Top + Height, X].Chr);
 For Y := Top + 1 to Top + H do
  If (Left + Width > 0) and (Left + Width <= 80) and (Y > 0) and (Y <= 25) then
  PutChar(Left + Width, Y, Black, DarkGray, Buffer^[Y, Left + Width].Chr);
end;

Procedure TWindow.Hide;
begin
 DrawInterface;
end;

Destructor TWindow.Destroy;
begin
 Hide;
end;

Constructor TMenu.Create(X, Y, B, C: Integer);
begin
 New(Window, Create('', X, Y, 2, 2, B, C));
 Root := NIL;
 Cur := NIL;
 Count := 0;
 ItemIndex := -1;
end;

Const
 KeyNames: Array[1..88] of String[4] = (
 'Esc',
 '1',
 '2',
 '3',
 '4',
 '5',
 '6',
 '7',
 '8',
 '9',
 '0',
 'Min',
 'Plus',
 'Bksp',
 'Tab',
 'Q',
 'W',
 'E',
 'R',
 'T',
 'Y',
 'U',
 'I',
 'O',
 'P',
 '[',
 ']',
 'Entr',
 'Ctrl',
 'A',
 'S',
 'D',
 'F',
 'G',
 'H',
 'J',
 'K',
 'L',
 ';',
 '''',
 '~',
 'LShf',
 '\',
 'Z',
 'X',
 'C',
 'V',
 'B',
 'N',
 'M',
 ',',
 '.',
 '/',
 'RShf',
 'PrSc',
 'Alt',
 'Spce',
 'Caps',
 'F1',
 'F2',
 'F3',
 'F4',
 'F5',
 'F6',
 'F7',
 'F8',
 'F9',
 'F10',
 'Num',
 'Scrl',
 'Home',
 #24,
 'PgUp',
 'Gr-',
 #27,
 'Cntr',
 #26,
 'Gr+',
 'End',
 #25,
 'PgDn',
 'Ins',
 'Del',
 '',
 '',
 '',
 'F11',
 'F12');

 sShift = 'Shift+';
 sCtrl  = 'Ctrl+';
 sAlt   = 'Alt+';

Function TMenu.AddItem(S: String; Alt, Ctrl, Shift: Boolean; Key: Byte; Com: Integer): PMenuItem;
Var W: Integer;
begin
 New(Result);
 If Root = NIL then
 begin
  Root := Result;
  Cur := Result;
 end Else
 begin
  Cur^.Next := Result;
  Cur := Result;
 end;
 With Result^ do
 begin
  Command := Com;
  Caption := S;
  Separator := False;
  Enabled := True;
  Checked := False;
  KeyComb.Alt := Alt;
  KeyComb.Ctrl := Ctrl;
  KeyComb.Shift := Shift;
  KeyComb.Key := Key;
  Next := NIL;
  W := Length(S) + 4;
  If Key > 0 then Inc(W, Length(KeyNames[Key]) +
   Byte(Alt) * Length(sAlt) +
   Byte(Shift) * Length(sShift) +
   Byte(Ctrl) * Length(sCtrl) + 1);
  With Window^ do If Width < W then Width := W;
 end;
 Inc(Count);
 Window^.Height := 2 + Count;
end;

Destructor TMenu.Destroy;
Var N: PMenuItem;
begin
 While Root <> NIL do
 begin
  N := Root^.Next;
  Dispose(Root);
  Root := N;
 end;
 Cur := NIL;
 Count := 0;
 ItemIndex := -1;
 Dispose(Window, Destroy);
end;

Function GetKeyString(KeyComb: TKeyComb): String;
begin
 With KeyComb do If Key > 0 then
 begin
  Result := KeyNames[Key];
  If Shift then Result := sShift + Result;
  If Ctrl then Result := sCtrl + Result;
  If Alt then Result := sAlt + Result;
 end Else Result := '';
end;

Procedure TMenu.Show;
Var N: PMenuItem; I, J: Integer; KS: String; Col: Byte;
begin
 Window^.Show;
 N := Root; I := 0;
 With Window^ do While N <> NIL do
 begin
  If N^.Enabled then Col := Color Else Col := DarkGray;
  If N^.Separator then
  begin
   PutChar(Left, Top + 1 + I, Background, Color, #195);
   For J := Left + 1 to Left + Width - 2 do
    PutChar(J, Top + 1 + I, Background, Color, #196);
   PutChar(Left + Width - 1, Top + 1 + I, Background, Color, #180);
  end Else
  begin
   If N^.Checked then PutChar(Left + 1, Top + 1 + I, Background, Col, #251);
   PutString(Left + 2, Top + 1 + I, Background, Col, N^.Caption);
   KS := GetKeyString(N^.KeyComb);
   For J := 0 to Length(KS) - 1 do PutChar((Left + Width - 3) - J, Top + 1 + I, Background, Col, KS[Length(KS) - J]);
   If I = ItemIndex then For J := 0 to Width - 1 do
    PutChar(Left + J, Top + 1 + I, Black, Background, Buffer^[Top + 1 + I, Left + J].Chr);
  end;
  Inc(I);
  N := N^.Next;
 end;
end;

Function TMenu.GetItem(Index: Integer): PMenuItem;
Var I: Integer; N: PMenuItem;
begin
 N := Root; I := 0;
 While N <> NIL do
 begin
  If I = Index then
  begin
   Result := N;
   Exit;
  end;
  Inc(I);
  N := N^.Next;
 end;
 Result := NIL;
end;

Procedure TMenu.Hide;
begin
 Window^.Hide;
end;

Procedure RomSeek(Pos: Integer);
begin
 If Pos < 0 then Pos := RomSize - 1;
 If Pos > RomSize - 1 then Pos := RomSize - 1;
 CurPage := Pos div 16;
 If CurPage > Pages - $10 then
 begin
  CurPage := Pages - $10;
  If CurPage < 0 then CurPage := 0;
 end;
 Row := 0;
 Col := 0;
 While (CurPage + Row) * 16 + Col <> Pos do
 begin
  Inc(Col);
  If Col = 16 then
  begin
   Inc(Row);
   Col := 0;
   If Row = 16 then
   begin
    Inc(CurPage);
    Row := 15;
   end;
  end;
 end;
end;

Type
 TMode = (mdHexpose, mdWindow, mdMenu);

Var
 I: Integer; F: File; Regs: Registers; Window: PWindow;
 Mode: TMode := mdHexpose; CurMenu: Integer := 0; Command: Integer := -1;
 InsScript: Boolean := False;

Procedure HexType(X: Pointer);
Var C: Char; D: DWord;
begin
 If X = NIL then Exit;
 With PComponent(X)^ do If KPressed and not SystemKey then
 begin
  If KurKey <= 57 then C := Symbs[False, KurKey] Else
  If NumState and (KurKey in [71..83]) then C := Numbers[KurKey-71] Else
   C := #0;
  Case C of
   '0'..'9', 'a'..'f': If Length(Text) < Width - 1 then
   begin
    Text := Text + UpCase(C);
    PComponents(Owner)^.Draw;
   end;
   #8: If Length(Text) > 0 then
   begin
    Dec(Byte(Text[0]));
    PComponents(Owner)^.Draw;
   end;
   #13: If InsScript and (Length(Text) > 0) then
   Declare
   Var F: System.Text; DS, S: String; B, I, J: Integer; ROMB: PByte; K: DWord;
   begin
    Second := False;
    K := HexVal(Text);
    If Window^.Components <> NIL then Dispose(Window^.Components, Done);
    Window^.Components := NIL;
    Window^.Hide;
    KPressed := False;
    GetDir(0, DS);
    S := FileSelect('*.txt');
    If (S <> '') and FileExists(S) then
    begin
     Assign(F, S);
     Reset(F);
     If K < RomSize then
     begin
      RomSeek(K);
      ROMB := Addr(Rom^[K]);
      With Table^ do
      While not EOF(F) do
      begin
       Readln(F, S);
       If Length(S) > 0 then
       begin
        I := 1;
        Repeat
         If S[I] = '<' then
         begin
          If (I + 4 <= Length(S)) and
             (S[I + 1] = '$') and
             (S[I + 4] = '>') then
          begin
           J := HexVal(Copy(S, I + 2, 2));
           If not HexError then B := 5 Else
           begin
            B := 1;
            J := -1;
           end;
          end Else If (I + 4 <= Length(S)) and (Copy(S, I, 5) = '<END>') then
          begin
           B := 5;
           J := GetCode(#254);
           If J < 0 then B := 1 Else Readln(F);
          end;
         end Else J := -1;
         If (J < 0) and (I + 1 <= Length(S)) then
         begin
          J := GetCode(S[I] + S[I + 1]);
          If J >= 0 then B := 2 Else
          begin
           J := GetCode(S[I]);
           B := 1;
          end;
         end;
         Inc(I, B);
         If J >= 0 then
         begin
          ROMB^ := J;
          Inc(DWord(ROMB));
          Inc(K);
          If K = RomSize then Break;
         end;
        Until I > Length(S);
       end;
       If not EOF(F) then
       begin
        J := GetCode(#25);
        If J >= 0 then
        begin
         ROMB^ := J;
         Inc(DWord(ROMB));
         Inc(K);
        end;
        If K = RomSize then Break;
       end Else Break;
      end;
     end;
     Close(F);
    end;
    ChDir(DS);
    DrawInterface;
    Mode := mdHexpose;
   end Else If not InsScript then
   begin
    Mode := mdHexpose;
    RomSeek(HexVal(Text));
    Second := False;
    If Window^.Components <> NIL then Dispose(Window^.Components, Done);
    Window^.Components := NIL;
    Window^.Hide;
   end;
  end;
  KPressed := False;
 end;
end;

Var
 Interval: Byte := 0;

Procedure SetInterval(X: Pointer);
Var C: Char; D: DWord;
begin
 If X = NIL then Exit;
 With PComponent(X)^ do If KPressed and not SystemKey then
 begin
  If KurKey <= 57 then C := Symbs[False, KurKey] Else
  If NumState and (KurKey in [71..83]) then C := Numbers[KurKey-71] Else
     C := #0;
  Case C of
   '0'..'9': If Length(Text) < Width - 1 then
   begin
    Text := Text + C;
    PComponents(Owner)^.Draw;
   end;
   #8: If Length(Text) > 0 then
   begin
    Dec(Byte(Text[0]));
    PComponents(Owner)^.Draw;
   end;
   #13:
   begin
    If Text <> '' then Interval := StrToInt(Text);
    Mode := mdHexpose;
    If Window^.Components <> NIL then Dispose(Window^.Components, Done);
    Window^.Components := NIL;
    Window^.Hide;
   end;
  end;
  KPressed := False;
 end;
end;

Var
 AnsiTable: PMenuItem;
 AsciiTable: PMenuItem;
 Table1: PMenuItem;
 Table2: PMenuItem;
 LoadTableItem: PMenuItem;
 CloseTableItem: PMenuItem;
 TableOptItem: PMenuItem;

Procedure NameType(X: Pointer);
Var C: Char; D: DWord; FileName: String;
begin
 If X = NIL then Exit;
 With PComponent(X)^ do If KPressed and not SystemKey then
 begin
  If KurKey = 74 then C := '-' Else
  If KurKey = 78 then C := '+' Else
  If ShiftPressed then
  begin
   If KurKey <= 57 then C := UpCase(ShiftSymbs[False, KurKey]) Else C := #0;
  end Else If KurKey <= 57 then C := UpCase(Symbs[False, KurKey]) Else C := #0;
  If NumState and (KurKey in [71..83]) then C := Numbers[KurKey-71];
  Case C of
   '0'..'9', 'A'..'Z', '~', '!', '_', '-': If Length(Text) < Width - 1 then
   begin
    Text := Text + UpCase(C);
    PComponents(Owner)^.Draw;
   end;
   #8: If Length(Text) > 0 then
   begin
    Dec(Byte(Text[0]));
    PComponents(Owner)^.Draw;
   end;
   #13: With Window^ do
   Declare
   Var N: PComponent;
   begin
    N := Components^.Root;
    FileName := N^.Text + '.' + N^.Next^.Text;
    If Table^.Save(FileName) then
    begin
     Mode := mdHexpose;
     If Components <> NIL then Dispose(Components, Done);
     Components := NIL;
     If Table1^.Checked then
      Table1^.Caption := FileName Else
      Table2^.Caption := FileName;
     Hide;
    end Else
    begin
     If Components <> NIL then Dispose(Components, Done);
     Components := NIL;
     Hide;
     Caption := '';
     Left := 31;
     Top := 9;
     Width := 18;
     Height := 5;
     Show;
     PutString(Left + 3, Top + 2, Background, 15, 'Cannot save.');
    end;
   end;
  end;
  KPressed := False;
 end;
end;

Var
 SearchNum: Byte := 0;
 SearchString: String := '';

Function SearchText(Text: String): Integer;
Var Start, Count, I, J: Integer; RA, RAA, TextStart: PByte; Memo: PBytes;
begin
 Result := -1;
 Start := (CurPage + Row) * 16 + Col + 1;
 If Start >= RomSize then Exit;
 Count := Byte(Text[0]);
 If Count = 0 then Exit;
 GetMem(Memo, Count);
 For I := 1 to Count do
 begin
  J := Table^.GetCode(Text[I]);
  If J < 0 then
  begin
   FreeMem(Memo, Count);
   Exit;
  end;
  Memo^[I - 1] := J;
 end;
 RA := Addr(Rom^[Start]);
 Repeat
  DWord(TextStart) := DWord(Memo);
  RAA := RA;
  I := 0;
  Repeat
   If RAA^ <> TextStart^ then Break;
   Inc(DWord(RAA));
   J := Interval;
   While J > 0 do
   begin
    Inc(DWord(RAA));
    Dec(J);
   end;
   Inc(DWord(TextStart));
   Inc(I);
  Until I = Count;
  If I = Count then
  begin
   Result := Start;
   FreeMem(Memo, Count);
   Exit;
  end;
  Inc(DWord(RA));
  Inc(Start);
  If Start > RomSize - Count * (1 + Interval) Then Break;
 Until False;
 FreeMem(Memo, Count);
end;

Function SearchHex(Text: String): Integer;
Var Start, Count, I, J: Integer; RA, RAA, TextStart: PByte; Memo: PBytes;
begin
 Result := -1;
 Start := (CurPage + Row) * 16 + Col + 1;
 If Start >= RomSize then Exit;
 Count := Byte(Text[0]);
 If Count mod 2 > 0 then Inc(Count);
 If Count = 0 then Exit;
 Count := Count div 2;
 GetMem(Memo, Count);
 For I := 0 to Count - 1 do
 begin
  J := HexVal(Text[I shl 1 + 1] + Text[I shl 1 + 2]);
  If HexError then
  begin
   FreeMem(Memo, Count);
   Exit;
  end;
  Memo^[I] := J;
 end;
 RA := Addr(Rom^[Start]);
 Repeat
  DWord(TextStart) := DWord(Memo);
  RAA := RA;
  I := 0;
  Repeat
   If RAA^ <> TextStart^ then Break;
   Inc(DWord(RAA));
   J := Interval;
   While J > 0 do
   begin
    Inc(DWord(RAA));
    Dec(J);
   end;
   Inc(DWord(TextStart));
   Inc(I);
  Until I = Count;
  If I = Count then
  begin
   Result := Start;
   FreeMem(Memo, Count);
   Exit;
  end;
  Inc(DWord(RA));
  Inc(Start);
  If Start > RomSize - Count * (1 + Interval) Then Break;
 Until False;
 FreeMem(Memo, Count);
end;

Procedure CreateTable(Chr: Char; Hex: Byte; Var TBL: PTable);
Var CC: Char; I, J, K: Integer;
begin
 New(TBL, Init);
 If Chr in ['A'..'Z'] then
 begin
  CC := 'A';
  J := HEX - (Byte(CHR) - Byte('A'));
  K := J   + (Byte('Z') - Byte('A'));
  For I := J to K do
  begin
   TBL^.Add(I, CC, White);
   Inc(Byte(CC));
  end;
 end Else If Chr in ['a'..'z'] then
 begin
  CC := 'a';
  J := HEX - (Byte(CHR) - Byte('a'));
  K := J   + (Byte('z') - Byte('a'));
  For I := J to K do
  begin
   TBL^.Add(I, CC, White);
   Inc(Byte(CC));
  end;
 end Else If Chr in [''..''] then
 begin
  CC := '';
  J := HEX - (Byte(CHR) - Byte(''));
  K := J   + (Byte('') - Byte(''));
  For I := J to K do
  begin
   TBL^.Add(I, AnsiToAscii(CC), White);
   Inc(Byte(CC));
  end;
 end Else If Chr in [''..''] then
 begin
  CC := '';
  J := HEX - (Byte(CHR) - Byte(''));
  K := J   + (Byte('') - Byte(''));
  For I := J to K do
  begin
   TBL^.Add(I, AnsiToAscii(CC), White);
   Inc(Byte(CC));
  end;
 end;
 Table := TBL;
end;

Function SearchRelative(Text: String): Integer;
Var MSize, TP, I, K1, K2: Integer; F: Boolean; B1, B2: ^Byte;
Label Start;
begin
 Result := -1;
 For I := 1 to Length(Text) do Text[I] := AsciiToAnsi(Text[I]);
 If Length(Text) > 1 then
 begin
  TP := (CurPage + Row) * 16 + Col + 1;
  If TP >= RomSize then Exit;
  MSize := Length(Text);
  Start:
  F := True;
  If MSize * (1 + Interval) + Tp <= RomSize then
  begin
   B1 := Addr(ROM^[TP]);
   For I := 1 to MSize - 1 do
   begin
    K1 := Ord(Text[I]) - Rom^[(I * (1 + Interval) - (1 + Interval)) + TP];
    K2 := Ord(Text[I + 1]) - Rom^[I * (1 + Interval) + TP];
    If K1 <> K2 then F := False;
   end;
   If F then
   begin
    F := False;
    For I := 2 to 3 do If Tables[I] = NIL then
    begin
     F := True;
     Break;
    end;
    If F then
    begin
     CreateTable(Text[1], Rom^[TP], Tables[I]);
     AnsiTable^.Checked := False;
     AsciiTable^.Checked := False;
     If I = 2 then
     begin
      Table1^.Checked := True;
      Table1^.Enabled := True;
      Table1^.Caption := 'Relative';
      Table2^.Checked := False;
     end Else
     begin
      Table1^.Checked := False;
      Table2^.Checked := True;
      Table2^.Enabled := True;
      Table2^.Caption := 'Relative';
     end;
     CloseTableItem^.Enabled := True;
    end Else
    begin
     If Tables[2] <> NIL then Dispose(Tables[2], Done);
     Tables[2] := NIL;
     CreateTable(Text[1], Rom^[TP], Tables[2]);
     AnsiTable^.Checked := False;
     AsciiTable^.Checked := False;
     Table1^.Checked := True;
     Table1^.Enabled := True;
     Table1^.Caption := 'Relative';
     Table2^.Checked := False;
     CloseTableItem^.Enabled := True;
    end;
    Result := TP;
    Exit;
   end;
   Inc(TP);
   Goto Start;
  end;
 end;
end;

Var
 Relative: Boolean;

Procedure TextType(X: Pointer);
Var C: Char; D: DWord;
begin
 If X = NIL then Exit;
 With PComponent(X)^ do If KPressed and not SystemKey then
 begin
  If ShiftPressed then
  begin
   If KurKey = 74 then C := '-' Else
   If KurKey = 78 then C := '+' Else
   If KurKey <= 57 then
   begin
    If CapsState then
     C := Symbs[RusType, KurKey] else
     C := ShiftSymbs[RusType, KurKey];
   end Else
   If NumState and (KurKey in [71..83]) then C := Numbers[KurKey - 71] Else
      C := #0;
  end Else
  begin
   If KurKey = 74 then C := '-' Else
   If KurKey = 78 then C := '+' Else
   If KurKey <= 57 then
   begin
    If CapsState then
     C := ShiftSymbs[RusType, KurKey] else
     C := Symbs[RusType, KurKey];
   end Else
   If NumState and (KurKey in [71..83]) then C := Numbers[KurKey - 71] Else
      C := #0;
  end;
  Case C of
   #32..#175, #224..#241: If Length(Text) < Width - 1 then
   begin
    Text := Text + C;
    PComponents(Owner)^.Draw;
   end;
   #8: If Length(Text) > 0 then
   begin
    Dec(Byte(Text[0]));
    PComponents(Owner)^.Draw;
   end;
   #13:
   Declare
   Var I: Integer; S: String;
   begin
    With Window^ do
    begin
     S := Text;
     If Components <> NIL then Dispose(Components, Done);
     Components := NIL;
     Second := False;
     Hide;
     ShowBuffer;
    end;
    If Relative then I := SearchRelative(S) Else I := SearchText(S);
    SearchString := '';
    If I >= 0 then
    begin
     If Relative then SearchNum := 3 Else SearchNum := 1;
     SearchString := S;
     RomSeek(I);
     DrawAll;
     Mode := mdHexpose;
    end Else With Window^ do
    begin
     Caption := '';
     Left := 28;
     Top := 9;
     Width := 23;
     Height := 5;
     Show;
     PutString(Left + 3, Top + 2, Background, 15, 'String not found.');
    end;
   end;
  end;
  KPressed := False;
 end;
end;

Procedure HexSearchType(X: Pointer);
Var C: Char; D: DWord;
begin
 If X = NIL then Exit;
 With PComponent(X)^ do If KPressed and not SystemKey then
 begin
  If KurKey <= 57 then C := Symbs[False, KurKey] Else
  If NumState and (KurKey in [71..83]) then C := Numbers[KurKey-71] Else C := #0;
  Case C of
   '0'..'9', 'a'..'f': If Length(Text) < Width - 1 then
   begin
    Text := Text + UpCase(C);
    PComponents(Owner)^.Draw;
   end;
   #8: If Length(Text) > 0 then
   begin
    Dec(Byte(Text[0]));
    PComponents(Owner)^.Draw;
   end;
   #13:
   Declare
   Var I: Integer; S: String;
   begin
    With Window^ do
    begin
     S := Text;
     If Components <> NIL then Dispose(Components, Done);
     Components := NIL;
     Second := False;
     Hide;
     ShowBuffer;
    end;
    I := SearchHex(S);
    SearchString := '';
    If I >= 0 then
    begin
     SearchNum := 2;
     SearchString := S;
     RomSeek(I);
     DrawAll;
     Mode := mdHexpose;
    end Else With Window^ do
    begin
     Caption := '';
     Left := 28;
     Top := 9;
     Width := 23;
     Height := 5;
     Show;
     PutString(Left + 3, Top + 2, Background, 15, 'String not found.');
    end;
   end;
  end;
  KPressed := False;
 end;
end;

Function DumpScript(B, E: DWord; FileName: String): Boolean;
Var F: Text; D: PByte; J: String; I: DWord; Color: Byte;
begin
 If FileName[Length(FileName)] = '.' then Dec(Byte(FileName[0]));
 If E >= RomSize then E := RomSize - 1;
 If B > E then Exit;
 Assign(F, FileName);
 {$I-}
 Rewrite(F);
 {$I+}
 If IOResult = 0 then
 begin
  Result := True;
  D := Addr(Rom^[B]);
  With Table^ do For I := B to E do
  begin
   J := GetCharacter(D^, Color);
   If CharFind then
   begin
    Case J[1] of
     #25: Writeln(F);
     #254:
     begin
      Writeln(F, '<END>');
      Writeln(F);
     end;
     Else Write(F, J);
    end;
   end Else Write(F, '<$' + IntToHex(D^, 2) + '>');
   Inc(DWord(D));
  end;
  Close(F);
 end Else Result := False;
end;

Procedure DumperNameType(X: Pointer);
Var C: Char; D: DWord;
begin
 If X = NIL then Exit;
 With PComponent(X)^ do If KPressed and not SystemKey then
 begin
  If KurKey = 74 then C := '-' Else
  If ShiftPressed then
  begin
   If KurKey <= 57 then C := UpCase(ShiftSymbs[False, KurKey]) Else C := #0;
  end Else If KurKey <= 57 then C := UpCase(Symbs[False, KurKey]) Else C := #0;
  If NumState and (KurKey in [71..83]) then C := Numbers[KurKey-71];
  Case C of
   '0'..'9', 'A'..'Z', '~', '!', '_', '-': If Length(Text) < Width - 1 then
   begin
    Text := Text + UpCase(C);
    PComponents(Owner)^.Draw;
   end;
   #8: If Length(Text) > 0 then
   begin
    Dec(Byte(Text[0]));
    PComponents(Owner)^.Draw;
   end;
   #13: With Window^ do
   Declare
   Var N: PComponent;
   begin
    N := Components^.Root;
    If (HexVal(N^.Next^.Text) >= HexVal(N^.Text)) and (N^.Next^.Next^.Text <> '') then
    begin
     If DumpScript(HexVal(N^.Text), HexVal(N^.Next^.Text), N^.Next^.Next^.Text + '.' + N^.Next^.Next^.Next^.Text) then
     begin
      Mode := mdHexpose;
      If Components <> NIL then Dispose(Components, Done);
      Components := NIL;
      Hide;
     end Else
     begin
      If Components <> NIL then Dispose(Components, Done);
      Components := NIL;
      Hide;
      Caption := '';
      Left := 31;
      Top := 9;
      Width := 18;
      Height := 5;
      Show;
      PutString(Left + 3, Top + 2, Background, 15, 'Cannot save.');
     end;
    end;
   end;
  end;
  KPressed := False;
 end;
end;

Procedure DumperHexType(X: Pointer);
Var C: Char; D: DWord;
begin
 If X = NIL then Exit;
 With PComponent(X)^ do If KPressed and not SystemKey then
 begin
  If KurKey <= 57 then C := Symbs[False, KurKey] Else
  If NumState and (KurKey in [71..83]) then C := Numbers[KurKey-71] Else
     C := #0;
  Case C of
   '0'..'9', 'a'..'f': If Length(Text) < Width - 1 then
   begin
    Text := Text + UpCase(C);
    PComponents(Owner)^.Draw;
   end;
   #8: If Length(Text) > 0 then
   begin
    Dec(Byte(Text[0]));
    PComponents(Owner)^.Draw;
   end;
   #13: With Window^ do
   Declare
   Var N: PComponent;
   begin
    N := Components^.Root;
    If (HexVal(N^.Next^.Text) >= HexVal(N^.Text)) and (N^.Next^.Next^.Text <> '') then
    begin
     If DumpScript(HexVal(N^.Text), HexVal(N^.Next^.Text), N^.Next^.Next^.Text + '.' + N^.Next^.Next^.Next^.Text) then
     begin
      Mode := mdHexpose;
      If Components <> NIL then Dispose(Components, Done);
      Components := NIL;
      Hide;
     end Else
     begin
      If Components <> NIL then Dispose(Components, Done);
      Components := NIL;
      Hide;
      Caption := '';
      Left := 31;
      Top := 9;
      Width := 18;
      Height := 5;
      Show;
      PutString(Left + 3, Top + 2, Background, 15, 'Cannot save.');
     end;
    end;
   end;
  end;
  KPressed := False;
 end;
end;

Label StartLoop, DrawLabel, Starter;
Var D: DirStr; N: NameStr; E: ExtStr;
begin
 TextMode(3);
 HideCursor;
 KeyboardOn(@KeyboardHandler);
 CapsState := TestCapsLock;
 NumState := TestNumLock;
 New(Buffer);
 FillChar(Buffer^, SizeOf(TTextData), 0);
 FileName := UpperCase(ParamStr(1));
 Starter:
 FSplit(FileName, D, N, E);
 FillChar(Regs, SizeOf(Registers), 0);
 FillChar(Tables, SizeOf(Tables), 0);
 FillChar(Menus, SizeOf(Menus), 0);
 If (FileName <> '') and FileExists(FileName) then
 begin
  Assign(F, FileName);
  Reset(F, 1);
  RomSize := FileSize(F);
  Pages := RomSize;
  While Pages mod 16 > 0 do Inc(Pages);
  Pages := Pages div 16;
  CurPage := 0;
  Row := 0;
  Col := 0;
  GetMem(Rom, RomSize);
  BlockRead(F, Rom^, RomSize);
  Close(F);
  CreateAnsiTable(0);
  CreateAsciiTable(1);
  Table := Tables[0];
  DrawInterface;
  New(Menus[0], Create(Pos('File',    Menu), 2, 7, 0));
  New(Menus[1], Create(Pos('Tables',  Menu), 2, 7, 0));
  New(Menus[2], Create(Pos('Edit',    Menu), 2, 7, 0));
  New(Menus[3], Create(Pos('Search',  Menu), 2, 7, 0));
  New(Menus[4], Create(Pos('Help',    Menu), 2, 7, 0));
  With Menus[0]^ do
  begin
   AddItem('Open...',   False, True,  False, 38, 0);
   AddItem('Save',      False, False, False, F5_Scan, 1);
   AddItem('Dump...',   False, False, False, F7_Scan, 2);
   AddItem('Insert...', False, False, False, F8_Scan, 3);
   AddItem('Exit',      False, True,  False, 16, 4);
   ItemIndex := 0;
  end;
  With Menus[1]^ do
  begin
   AnsiTable := AddItem('ANSI Table',    True,  False, False, 02, 5);
   AnsiTable^.Checked := True;
   AsciiTable := AddItem('ASCII Table',   True,  False, False, 03, 6);
   Table1 := AddItem('No Table',      True,  False, False, 04, 7);
   Table1^.Enabled := False;
   Table2 := AddItem('No Table',      True,  False, False, 05, 8);
   Table2^.Enabled := False;
   AddItem('',              False, False, False, 00, -1)^.Separator := True;
   LoadTableItem := AddItem('Load Table...', False, True,  False, 20{F9_Scan}, 9);
   AddItem('Save Table...', False, True, False, 31{F9_Scan}, 10);
   CloseTableItem := AddItem('Close Table', False, True, False, 45, 18);
   CloseTableItem^.Enabled := False;
   AddItem('',              False, False, False, 00, -1)^.Separator := True;
   TableOptItem := AddItem('Use ANSI-1251', False, True, False, 17, 99);
   ItemIndex := 0;
  end;
  With Menus[2]^ do
  begin
   AddItem('Goto...',   False, False, False, F1_Scan, 11);
   ItemIndex := 0;
  end;
  With Menus[3]^ do
  begin
   AddItem('Text...',     False, False, False, F2_Scan, 12);
   AddItem('Hex...',      False, False, False, F4_Scan, 13);
   AddItem('Relative...', False, False, False, F6_Scan, 14);
   AddItem('Again',       False, False, False, F3_Scan, 15);
   AddItem('',       False, False, False, 0, -1)^.Separator := True;
   AddItem('Set interval...', False, True, False, 23, 19);
   ItemIndex := 0;
  end;
  With Menus[4]^ do
  begin
   AddItem('Commands...', False, True,  False, F1_Scan, 16);
   AddItem('About...',    False, False, True,  F1_Scan, 17);
   ItemIndex := 0;
  end;
  If FileExists(N + '.TBL') then
  begin
   New(Tables[2], Init);
   Tables[2]^.Load(N + '.TBL');
   Table1^.Caption := N + '.TBL';
   Table1^.Enabled := True;
   AnsiTable^.Checked := False;
   AsciiTable^.Checked := False;
   Table1^.Checked := True;
   Table2^.Checked := False;
   CloseTableItem^.Enabled := True;
   Table := Tables[2];
   DrawAll;
  end;
  New(Window, Create('', 1, 1, 2, 2, Red, Yellow));
  Repeat
   StartLoop:
   If KurKey = Caps_Scan then
   begin
    DrawRusType;
    KPressed := False;
   end Else
   If ShiftPressed and KPressed and (KurKey = Ctrl_Scan) then
   begin
    RusType := not RusType;
    DrawRusType;
    KPressed := False;
   end;
   If Mode = mdHexpose then
   begin
    If KPressed then
    Declare
    Var B: Boolean; N: PMenuItem;
    begin
     B := False;
     For I := 0 to 4 do With Menus[I]^ do
     begin
      N := Root;
      While N <> NIL do
      begin
       If N^.Enabled then
       With N^.KeyComb do If (Key > 0) and (Key < 128) and
       ((Alt and AltPressed) or not (Alt and not AltPressed)) and
       ((Shift and ShiftPressed) or (not Shift and not ShiftPressed)) and
       ((Ctrl and CtrlPressed) or (not Ctrl and not CtrlPressed)) and
       (KurKey = Key) then
       begin
        B := True;
        Command := N^.Command;
        Break;
       end;
       N := N^.Next;
      end;
      If B then Break;
     end;
     If not B and SystemKey then
     Case KurKey of
      Esc_Scan:
      begin
       Mode := mdMenu;
       Menus[CurMenu]^.Show;
       KPressed := False;
      end;
      Tab_Scan:
      begin
       HexEdit := not HexEdit;
       Second := False;
       Goto DrawLabel;
      end;
      Down_Scan:
      begin
       MoveDown;
       Second := False;
       Goto DrawLabel;
      end;
      Up_Scan:
      begin
       MoveUp;
       Second := False;
       Goto DrawLabel;
      end;
      Left_Scan:
      begin
       MoveLeft;
       Second := False;
       Goto DrawLabel;
      end;
      Right_Scan:
      begin
       MoveRight;
       Second := False;
       Goto DrawLabel;
      end;
      PgDn_Scan:
      begin
       If CtrlPressed then
       begin
        Row := 15;
        Col := 15;
        CurPage := Pages - $10;
        If CurPage < 0 then CurPage := 0;
       end Else For I := 0 to 15 do
       begin
        Inc(CurPage);
        If CurPage > Pages - $10 then
        begin
         CurPage := Pages - $10;
         If CurPage < 0 then CurPage := 0;
         Break;
        end;
       end;
       Second := False;
       Goto DrawLabel;
      end;
      PgUp_Scan:
      begin
       If CtrlPressed then
       begin
        Row := 0;
        Col := 0;
        CurPage := 0;
       end Else For I := 0 to 15 do
       begin
        Dec(CurPage);
        If CurPage < 0 then
        begin
         CurPage := 0;
         Break;
        end;
       end;
       Second := False;
       Goto DrawLabel;
      end;
      Home_Scan:
      begin
       Col := 0;
       If CtrlPressed then Row := 0;
       Second := False;
       Goto DrawLabel;
      end;
      End_Scan:
      begin
       Col := 15;
       If CtrlPressed then Row := 15;
       Second := False;
       Goto DrawLabel;
      end;
      Else Goto DrawLabel;
     end;
    end;
    If HexEdit and not AltPressed and not CtrlPressed then
    begin
     Declare
     Var C: Char;
     begin
      If KurKey <= 57 then C := Symbs[False, KurKey] Else
      If NumState and (KurKey in [71..83]) then C := Numbers[KurKey-71] Else
       C := #0;
      If KPressed then
      Case C of
       #8:
       begin
        If Second then Second := False Else
        begin
         Second := True;
         MoveLeft;
        end;
        Goto DrawLabel;
       end;
       ' ':
       begin
        If not Second then Second := True Else
        begin
         Second := False;
         MoveRight;
        end;
        Goto DrawLabel;
       end;
       '0'..'9':
       begin
        If not Second then
        begin
         CurRomByte^ := CurRomByte^ and $0F + (Byte(C) - 48) shl 4;
         Second := True;
        end Else
        begin
         CurRomByte^ := CurRomByte^ and $F0 + (Byte(C) - 48);
         Second := False;
         MoveRight;
        end;
        Goto DrawLabel;
       end;
       'a'..'f':
       begin
        If not Second then
        begin
         CurRomByte^ := CurRomByte^ and $0F + (Byte(C) - 87) shl 4;
         Second := True;
        end Else
        begin
         CurRomByte^ := CurRomByte^ and $F0 + (Byte(C) - 87);
         Second := False;
         MoveRight;
        end;
        Goto DrawLabel;
       end;
      end;
     end;
    end Else If not AltPressed and not CtrlPressed then
    begin
     Declare
     Var C: Char; CodeX: Integer;
     begin
      If KurKey = 74 then C := '-' Else
      If KurKey = 78 then C := '+' Else
      If KurKey <= 57 then C := Symbs[RusType, KurKey] Else
      If NumState and (KurKey in [71..83]) then C := Numbers[KurKey - 71] Else
       C := #0;
      If KPressed then
      Case C of
       #32..#175, #224..#241:
       If ShiftPressed then
       begin
        If KurKey = 74 then CodeX := Table^.GetCode('-') Else
        If KurKey = 78 then CodeX := Table^.GetCode('+') Else
        If NumState and (KurKey in [71..83]) then
         CodeX := Table^.GetCode(Numbers[KurKey - 71]) Else
        If CapsState then
         CodeX := Table^.GetCode(Symbs[RusType, KurKey]) Else
         CodeX := Table^.GetCode(ShiftSymbs[RusType, KurKey]);
        If CodeX >= 0 then
        begin
         CurRomByte^ := CodeX;
         MoveRight;
         Goto DrawLabel;
        end;
       end Else
       begin
        If KurKey = 74 then CodeX := Table^.GetCode('-') Else
        If KurKey = 78 then CodeX := Table^.GetCode('+') Else
        If NumState and (KurKey in [71..83]) then
         CodeX := Table^.GetCode(Numbers[KurKey - 71]) Else
        If CapsState then
         CodeX := Table^.GetCode(ShiftSymbs[RusType, KurKey]) Else
         CodeX := Table^.GetCode(Symbs[RusType, KurKey]);
        If CodeX >= 0 then
        begin
         CurRomByte^ := CodeX;
         MoveRight;
         Goto DrawLabel;
        end;
       end;
       #8:
       begin
        MoveLeft;
        Goto DrawLabel;
       end;
       #13:
       begin
        CodeX := Table^.GetCode(#25);
        If CodeX >= 0 then
        begin
         CurRomByte^ := CodeX;
         MoveRight;
         Goto DrawLabel;
        end;
       end;
      end;
     end;
    end;
   end Else If Mode = mdMenu then
   begin
    If KPressed then
    Case KurKey of
     Esc_Scan:
     begin
      Mode := mdHexpose;
      Menus[CurMenu]^.Hide;
      KPressed := False;
     end;
     Left_Scan:
     begin
      Menus[CurMenu]^.Hide;
      Dec(CurMenu);
      If CurMenu < 0 then CurMenu := 4;
      Menus[CurMenu]^.Show;
      KPressed := False;
     end;
     Right_Scan:
     begin
      Menus[CurMenu]^.Hide;
      Inc(CurMenu);
      If CurMenu > 4 then CurMenu := 0;
      Menus[CurMenu]^.Show;
      KPressed := False;
     end;
     Down_Scan: With Menus[CurMenu]^ do If ItemIndex >= 0 then
     begin
      Inc(ItemIndex);
      If ItemIndex >= Count then ItemIndex := 0;
      If GetItem(ItemIndex)^.Separator then
      begin
       Inc(ItemIndex);
       If ItemIndex >= Count then ItemIndex := 0;
       If GetItem(ItemIndex)^.Separator then ItemIndex := -1;
      end;
      Show;
      KPressed := False;
     end;
     Up_Scan: With Menus[CurMenu]^ do If ItemIndex >= 0 then
     begin
      Dec(ItemIndex);
      If ItemIndex < 0 then ItemIndex := Count - 1;
      If GetItem(ItemIndex)^.Separator then
      begin
       Dec(ItemIndex);
       If ItemIndex < 0 then ItemIndex := Count - 1;
       If GetItem(ItemIndex)^.Separator then ItemIndex := -1;
      end;
      Show;
      KPressed := False;
     end;
     Home_Scan: With Menus[CurMenu]^ do If ItemIndex >= 0 then
     begin
      ItemIndex := 0;
      While GetItem(ItemIndex)^.Separator do
      begin
       Inc(ItemIndex);
       If ItemIndex = Count then
       begin
        ItemIndex := -1;
        Break;
       end;
      end;
      Show;
      KPressed := False;
     end;
     End_Scan: With Menus[CurMenu]^ do If ItemIndex >= 0 then
     begin
      ItemIndex := Count - 1;
      While GetItem(ItemIndex)^.Separator do
      begin
       Dec(ItemIndex);
       If ItemIndex < 0 then Break;
      end;
      Show;
      KPressed := False;
     end;
     Ent_Scan: With Menus[CurMenu]^ do If ItemIndex >= 0 then
     Declare
     Var M: PMenuItem;
     begin
      M := GetItem(ItemIndex);
      If M^.Enabled then
      begin
       Command := M^.Command;
       Hide;
       Mode := mdHexpose;
      end;
      KPressed := False;
     end;
    end;
   end Else If Mode = mdWindow then
   begin
    If KPressed then
     Case KurKey of
      Esc_Scan:
      begin
       If Window^.Components <> NIL then Dispose(Window^.Components, Done);
       Window^.Components := NIL;
       Window^.Hide;
       Mode := mdHexpose;
       ShowBuffer;
       KPressed := False
      end;
      Tab_Scan: With Window^ do If Components <> NIL then With Components^ do
      begin
       Inc(ItemIndex);
       If ItemIndex = Count then ItemIndex := 0;
       Draw;
       KPressed := False
      end;
     end;
    With Window^ do If Components <> NIL then With Components^ do
    Declare
    Var N: PComponent;
    begin
     N := GetComponent(ItemIndex);
     N^.Process(N);
    end;
   end;
   Case Command of
    00:
    Declare
    Var FName: String;
    begin
     FName := FileSelect('*.*');
     If (FName <> '') and FileExists(FName) then
     begin
      FileName := FName;
      FSplit(FileName, D, N, E);
      FreeMem(Rom, RomSize);
      Assign(F, FName);
      Reset(F, 1);
      RomSize := FileSize(F);
      GetMem(Rom, RomSize);
      BlockRead(F, Rom^, RomSize);
      Close(F);
      Pages := RomSize;
      While Pages mod 16 > 0 do Inc(Pages);
      Pages := Pages div 16;
      CurPage := 0;
      Row := 0;
      Col := 0;
      If FileExists(N + '.TBL') then
      begin
       If Tables[2] <> NIL then Dispose(Tables[2], Done);
       If Tables[3] <> NIL then Dispose(Tables[3], Done);
       Table2^.Caption := 'No Table';
       Table2^.Enabled := False;
       Tables[3] := NIL;
       New(Tables[2], Init);
       Tables[2]^.Load(N + '.TBL');
       Table1^.Caption := N + '.TBL';
       Table1^.Enabled := True;
       AnsiTable^.Checked := False;
       AsciiTable^.Checked := False;
       Table1^.Checked := True;
       Table2^.Checked := False;
       CloseTableItem^.Enabled := True;
       Table := Tables[2];
      end;
     end;
     DrawInterface;
    end;
    01: With Window^ do
    begin
     Assign(F, FileName);
     {$I-}
     Rewrite(F, 1);
     {$I+}
     If IOResult = 0 then
     begin
      BlockWrite(F, Rom^, RomSize);
      Close(F);
      Caption := '';
      Left := 30;
      Top := 9;
      Width := 20;
      Height := 5;
      Show;
      PutString(Left + 3, Top + 2, Background, 15, 'Changes saved.');
     end Else
     begin
      Caption := '';
      Left := 31;
      Top := 9;
      Width := 18;
      Height := 5;
      Show;
      PutString(Left + 3, Top + 2, Background, 15, 'Cannot save.');
     end;
     Mode := mdWindow;
    end;
    02: With Window^ do
    begin
     Caption := 'Script dumper';
     Left := 26;
     Top := 7;
     Width := 28;
     Height := 9;
     Show;
     PutString(Left + 2, Top + 2, Background, 15, 'Start offset:');
     PutString(Left + 2, Top + 4, Background, 15, 'End offset:');
     PutString(Left + 2, Top + 6, Background, 15, 'Filename:');
     New(Components, Init);
     Components^.Add(IntToHex((CurPage + Row) * 16 + Col, 8), Left + 17, Top + 2, 9, 0, 15, DumperHexType)^.Cursor := 0;
     Components^.Add('', Left + 17, Top + 4, 9, 0, 15, DumperHexType)^.Cursor := 0;
     Components^.Add('', Left + 12, Top + 6, 9, 0, 15, DumperNameType)^.Cursor := 0;
     Components^.Add('TXT', Left + 22, Top + 6, 4, 0, 15, DumperNameType)^.Cursor := 0;
     Components^.ItemIndex := 0;
     Components^.Draw;
     Mode := mdWindow;
    end;
    03: With Window^ do
    begin
     Caption := 'Script inserter';
     Left := 27;
     Top := 9;
     Width := 23;
     Height := 5;
     Show;
     PutString(Left + 3, Top + 2, Background, 15, 'Offset:');
     New(Components, Init);
     InsScript := True;
     Components^.Add(IntToHex((CurPage + Row) * 16 + Col, 8), Left + 11, Top + 2, 9, 0, 15, HexType)^.Cursor := 0;
     Components^.ItemIndex := 0;
     Components^.Draw;
     Mode := mdWindow;
    end;
    04: Break;
    05:
    begin
     AnsiTable^.Checked := True;
     AsciiTable^.Checked := False;
     Table1^.Checked := False;
     Table2^.Checked := False;
     CloseTableItem^.Enabled := False;
     Table := Tables[0];
     DrawAll;
     KPressed := False;
    end;
    06:
    begin
     AnsiTable^.Checked := False;
     AsciiTable^.Checked := True;
     Table1^.Checked := False;
     Table2^.Checked := False;
     Table := Tables[1];
     CloseTableItem^.Enabled := False;
     DrawAll;
     KPressed := False;
    end;
    07:
    begin
     AnsiTable^.Checked := False;
     AsciiTable^.Checked := False;
     Table1^.Checked := True;
     Table2^.Checked := False;
     CloseTableItem^.Enabled := True;
     Table := Tables[2];
     DrawAll;
     KPressed := False;
    end;
    08:
    begin
     AnsiTable^.Checked := False;
     AsciiTable^.Checked := False;
     Table1^.Checked := False;
     Table2^.Checked := True;
     CloseTableItem^.Enabled := True;
     Table := Tables[3];
     DrawAll;
     KPressed := False;
    end;
    09:
    Declare
    Var FName, DS: String;
    begin
     GetDir(0, DS);
     FName := FileSelect('*.tbl');
     If (FName <> '') and FileExists(FName) then
     begin
      For I := 0 to 3 do If Tables[I] = NIL then
      begin
       New(Tables[I], Init);
       Tables[I]^.Load(FName);
       AnsiTable^.Checked := False;
       AsciiTable^.Checked := False;
       If I = 2 then
       begin
        Table1^.Caption := FName;
        Table1^.Enabled := True;
        Table1^.Checked := True;
        Table2^.Checked := False;
       end Else
       begin
        Table2^.Caption := FName;
        Table2^.Enabled := True;
        Table1^.Checked := False;
        Table2^.Checked := True;
       end;
       CloseTableItem^.Enabled := True;
       Table := Tables[I];
       Break;
      end;
      LoadTableItem^.Enabled := False;
      For I := 0 to 3 do If Tables[I] = NIL then
      begin
       LoadTableItem^.Enabled := True;
       Break;
      end;
     end;
     ChDir(DS);
     DrawInterface;
    end;
    10: With Window^ do
    begin
     Caption := 'Save table';
     Left := 26;
     Top := 9;
     Width := 28;
     Height := 5;
     Show;
     PutString(Left + 2, Top + 2, Background, 15, 'Filename:');
     New(Components, Init);
     Components^.Add('', Left + 12, Top + 2, 9, 0, 15, NameType)^.Cursor := 0;
     Components^.Add('TBL', Left + 22, Top + 2, 4, 0, 15, NameType)^.Cursor := 0;
     Components^.ItemIndex := 0;
     Components^.Draw;
     Mode := mdWindow;
    end;
    11: With Window^ do
    begin
     Caption := 'Goto offset';
     Left := 27;
     Top := 9;
     Width := 23;
     Height := 5;
     Show;
     PutString(Left + 3, Top + 2, Background, 15, 'Offset:');
     InsScript := False;
     New(Components, Init);
     Components^.Add('', Left + 11, Top + 2, 9, 0, 15, HexType)^.Cursor := 0;
     Components^.ItemIndex := 0;
     Components^.Draw;
     Mode := mdWindow;
    end;
    12: With Window^ do
    begin
     Caption := 'Search text';
     Left := 25;
     Top := 9;
     Width := 29;
     Height := 5;
     Show;
     PutString(Left + 3, Top + 2, Background, 15, 'Text:');
     New(Components, Init);
     Components^.Add('', Left + 9, Top + 2, 17, 0, 15, TextType)^.Cursor := 0;
     Components^.ItemIndex := 0;
     Components^.Draw;
     Relative := False;
     Mode := mdWindow;
    end;
    13: With Window^ do
    begin
     Caption := 'Search hex';
     Left := 19;
     Top := 9;
     Width := 44;
     Height := 5;
     Show;
     PutString(Left + 3, Top + 2, Background, 15, 'Hex:');
     New(Components, Init);
     Components^.Add('', Left + 8, Top + 2, 33, 0, 15, HexSearchType)^.Cursor := 0;
     Components^.ItemIndex := 0;
     Components^.Draw;
     Mode := mdWindow;
    end;
    14: With Window^ do
    begin
     Caption := 'Search relative';
     Left := 25;
     Top := 9;
     Width := 29;
     Height := 5;
     Show;
     PutString(Left + 3, Top + 2, Background, 15, 'Text:');
     New(Components, Init);
     Components^.Add('', Left + 9, Top + 2, 17, 0, 15, TextType)^.Cursor := 0;
     Components^.ItemIndex := 0;
     Components^.Draw;
     Relative := True;
     Mode := mdWindow;
    end;
    15: If SearchString <> '' then
    begin
     I := -1;
     Case SearchNum of
      1: I := SearchText(SearchString);
      2: I := SearchHex(SearchString);
      3: I := SearchRelative(SearchString);
     end;
     If I >= 0 then
     begin
      RomSeek(I);
      DrawAll;
      ShowBuffer;
      KPressed := False;
     end Else With Window^ do
     begin
      Caption := '';
      Left := 28;
      Top := 9;
      Width := 23;
      Height := 5;
      Show;
      PutString(Left + 3, Top + 2, Background, 15, 'String not found.');
      Mode := mdWindow;
     end;
    end;
    16: With Window^ do
    begin
     Caption := 'Commands';
     Left := 21;
     Top := 4;
     Width := 36;
     Height := 17;
     Show;
     PutString(Left + 3, Top + 2, Background, 15, 'TAB     Toggle mode (hex/text)');
     PutString(Left + 3, Top + 3, Background, 15, 'ESC              Bring up menu');
     PutString(Left + 3, Top + 4, Background, 15, 'Shift+Ctrl      Toggle LAT/RUS');
     PutString(Left + 3, Top + 5, Background, 15, 'F1                Go to offset');
     PutString(Left + 3, Top + 6, Background, 15, 'F2                 Text search');
     PutString(Left + 3, Top + 7, Background, 15, 'F3                Search again');
     PutString(Left + 3, Top + 8, Background, 15, 'F4                  Hex search');
     PutString(Left + 3, Top + 9, Background, 15, 'F5                Save changes');
     PutString(Left + 3, Top + 10,Background, 15, 'F6             Relative search');
     PutString(Left + 3, Top + 11,Background, 15, 'F7               Script dumper');
     PutString(Left + 3, Top + 12,Background, 15, 'F8             Script inserter');
     PutString(Left + 3, Top + 13,Background, 15, 'Ctrl+L           File selector');
     PutString(Left + 3, Top + 14,Background, 15, 'Ctrl+Q                    Quit');
     Mode := mdWindow;
    end;
    17: With Window^ do
    begin
     Caption := 'About';
     Left := 23;
     Top := 7;
     Width := 32;
     Height := 10;
     Show;
     PutString(Left + 8, Top + 2, Background, 15, 'Hexposure v3.666');
     PutString(Left + 8, Top + 4, Background, 15, 'Written by Djinn');
     PutString(Left + 7, Top + 5, Background, 15, '(c)2008 Magic Team');
     PutString(Left + 4, Top + 6, Background, 15, 'Based on Hexposure v0.44');
     PutString(Left + 9, Top + 7, Background, 15, 'by Kent Hansen');
     Mode := mdWindow;
    end;
    18:
    begin
     If Table1^.Checked then
     begin
      If Tables[2] <> NIL then Dispose(Tables[2], Done);
      Tables[2] := NIL;
      Table1^.Caption := 'No Table';
      Table1^.Enabled := False;
      Table1^.Checked := False;
      If Table2^.Enabled then
      begin
       Table2^.Checked := True;
       CloseTableItem^.Enabled := True;
       Table := Tables[3];
       DrawAll;
      end Else
      begin
       AnsiTable^.Checked := True;
       CloseTableItem^.Enabled := False;
       Table := Tables[0];
       DrawAll;
      end;
      LoadTableItem^.Enabled := True;
     end Else If Table2^.Checked then
     begin
      If Tables[3] <> NIL then Dispose(Tables[3], Done);
      Tables[3] := NIL;
      Table2^.Caption := 'No Table';
      Table2^.Enabled := False;
      Table2^.Checked := False;
      If Table1^.Enabled then
      begin
       Table1^.Checked := True;
       CloseTableItem^.Enabled := True;
       Table := Tables[2];
       DrawAll;
      end Else
      begin
       AnsiTable^.Checked := True;
       CloseTableItem^.Enabled := False;
       Table := Tables[0];
       DrawAll;
      end;
      LoadTableItem^.Enabled := True;
     end;
    end;
    19: With Window^ do
    begin
     Caption := 'Search interval';
     Left := 30;
     Top := 9;
     Width := 21;
     Height := 5;
     Show;
     PutString(Left + 3, Top + 2, Background, 15, 'Interval:');
     New(Components, Init);
     Components^.Add(IntToStr(Interval), Left + 15, Top + 2, 3, 0, 15, SetInterval)^.Cursor := 0;
     Components^.ItemIndex := 0;
     Components^.Draw;
     Mode := mdWindow;
    end;
    99:
    begin
     With TableOptItem^ do Checked := not Checked;
     ANSIMode := not ANSIMode;
     KPressed := False;
    end;
   end;
   Command := -1;
   With Regs do
   begin
    AH := $2C;
    Intr($21, Regs);
    PutString(71, 25, 7, 0,
    ZeroString(IntToStr(CH), 2) + ':' +
    ZeroString(IntToStr(CL), 2) + ':' +
    ZeroString(IntToStr(DH), 2));
    ShowBuffer;
   end;
   Goto StartLoop;
   DrawLabel:
   DrawAll;
   ShowBuffer;
   KPressed := False;
  Until False;
  Dispose(Window, Destroy);
  For I := 0 to 4 do If Menus[I] <> NIL then Dispose(Menus[I], Destroy);
  FreeTables;
  FreeMem(Rom, RomSize);
 end Else
 begin
  FileName := FileSelect('*.*');
  If FileName <> '' then Goto Starter;
 end;
 Dispose(Buffer);
 ClrScr;
 ShowCursor;
 KeyboardOff;
end.