Unit Needs;

Interface

Uses Use32;

Type
 TTextAttr = Record
  Chr: Char;
  Atr: Byte;
 end;
 TTextData = Array[1..25, 1..80] of TTextAttr;
 PBytes = ^TBytes;
 TBytes = Array[Word] of Byte;

Var
 KPressed: Boolean := False;
 CapsState: Boolean := False;
 NumState: Boolean := False;
 Buffer: ^TTextData;
 Screen: ^TTextData := Pointer($000B8000);
 HexError: Boolean := False;
 CtrlPressed, ShiftPressed, AltPressed: Boolean;
 KurKey: Byte;

Function FileExists(FileName: String): Boolean;
Procedure ShowBuffer;
Function ZeroString(S: String; NL: Integer): String;
Function SpaceString(S: String; NL: Integer): String;
Procedure PutChar(X, Y: Integer; B, C: Byte; Ch: Char);
Procedure PutString(X, Y: Integer; B, C: Byte; S: String);
Function HexVal(s: string): DWord;

Implementation

Procedure ShowBuffer;
begin
 Move(Buffer^, Screen^, SizeOf(TTextData));
end;

Function ZeroString(S: String; NL: Integer): String;
begin
 While Length(S) < NL do S := '0' + S;
 If Length(S) > NL then S[0] := Char(NL);
 Result := S;
end;

Function SpaceString(S: String; NL: Integer): String;
begin
 While Length(S) < NL do S := ' ' + S;
 If Length(S) > NL then S[0] := Char(NL);
 Result := S;
end;

Procedure PutChar(X, Y: Integer; B, C: Byte; Ch: Char);
Var CC: PByte;
begin
 If X < 1 then Exit;
 If X > 80 then Exit;
 If Y < 1 then Exit;
 If Y > 25 then Exit;
 With Buffer^[Y, X] do
 begin
  Chr := Ch;
  Atr := (C and $0F) or ((B and $0F) shl 4);
 end;
end;

Procedure PutString(X, Y: Integer; B, C: Byte; S: String);
Var I: Integer;
begin
 For I := 1 to Length(S) do PutChar(X + I - 1, Y, B, C, S[I]);
end;

Function FileExists(FileName: String): Boolean;
Var F: File;
begin
 Result := False;
 Assign(F, FileName);
 Reset(F, 1);
 If IOResult = 0 then
 begin
  Result := FileSize(F) > 0;
  Close(F);
 end;
end;

Function HexVal(s: string): DWord;
Function sign(h: Char): Byte;
begin
 if h in ['0'..'9'] then Result := Byte(h) - 48 Else
 if h in ['A'..'F'] then Result := Byte(h) - 55 Else
                         Result := Byte(h) - 87;
end;
Const hs: Array[1..8] of DWord = ($1,
                                  $10,
                                  $100,
                                  $1000,
                                  $10000,
                                  $100000,
                                  $1000000,
                                  $10000000);
Var i: Byte; Label Error;
begin
 hexerror := true;
 Result := 0;
 If Length(s) <= 8 then
 begin
  For i := 1 to Length(s) do If not (s[i] in ['0'..'9', 'A'..'F', 'a'..'f']) then Goto Error;
  Result := 0;
  for i := 1 to Length(s) do Inc(Result, sign(s[i]) * hs[length(s) + 1 - i]);
  hexerror := false;
 end Else
 begin Error:
  hexerror := true;
 end;
end;

end.